Package: CyTOFpower
Type: Package
Title: Power analysis for CyTOF experiments
Version: 1.19.1
Authors@R: c(person("Anne-Maud", "Ferreira",
           email = "anne-maud.ferreira@epfedu.fr",
           role = c("cre", "aut"),
           comment = c(ORCID = "0000-0002-4749-746X")),
    person("Catherine", "Blish",
            email = "cblish@stanford.edu",
            role = c("aut")),
    person("Susan", "Holmes",
            email = "sph@stanford.edu",
            role = c("aut")))
Description: This package is a tool to predict the power of CyTOF 
    experiments in the context of differential state analyses. The package provides 
    a shiny app with two options to predict the power of an experiment: 
    i. generation of in-sicilico CyTOF data, using users input ii. browsing in a 
    grid of parameters for which the power was already precomputed.
biocViews: FlowCytometry, SingleCell, CellBiology, StatisticalMethod,
        Software
License: LGPL-3
Encoding: UTF-8
Depends: R (>= 4.1)
Imports: CytoGLMM, diffcyt, DT, dplyr, ggplot2, magrittr, methods,
        rlang, stats, shiny, shinyFeedback, shinyjs, shinyMatrix,
        SummarizedExperiment, tibble, tidyr
RoxygenNote: 7.1.2
VignetteBuilder: knitr
Suggests: testthat (>= 3.0.0), BiocStyle, knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/CyTOFpower
git_branch: devel
git_last_commit: b8a8306
git_last_commit_date: 2026-05-02
Repository: Bioconductor 3.24
Date/Publication: 2026-05-12
NeedsCompilation: no
Packaged: 2026-05-12 21:12:10 UTC; biocbuild
Author: Anne-Maud Ferreira [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-4749-746X>),
  Catherine Blish [aut],
  Susan Holmes [aut]
Maintainer: Anne-Maud Ferreira <anne-maud.ferreira@epfedu.fr>

# CyTOFpower

## Description

This package is a tool to predict the power of CyTOF experiments, in the context 
of differential state analyses using `CytoGLMM` or `diffcyt` packages. 
This package provides a shiny app with two options to predict the power of an 
experiment. One part generates in-sicilico CyTOF data, using users input parameters 
(for instance the number of markers, the number of cells, or the expected fold 
change for the differential expressed markers). And the other part allows the user 
to browse in a grid of parameters for which the power was precomputed.

# Installation

To install the package from github:

```r
if (!requireNamespace("devtools", quietly = TRUE)){
     install.packages("devtools")
}
devtools::install_github("FerreiraAM/CyTOFpower")
```

## Example

More information are available in the vignette:

```r
vignette("CyTOFpower", package = "CyTOFpower")
```

# Server
appServer <- function(input, output, session){

  # Precomputed datasets
  observeEvent(input$p_goButton,{

    # Warning on NA
    observe({
      # Create a vector checking if all possible parameters == NA
      na_tf <- c(input$p_nb_cells == "NA",
                 input$p_nb_donors == "NA",
                 input$p_subeff == "NA",
                 input$p_mu0 == "NA",
                 input$p_dispersion == "NA")
      # Count the number of NA
      nb_na <- sum(na_tf, na.rm=TRUE)
      # Is the number of NA above 1
      nb_na_error <- nb_na > 1
      # Display message
      output$na_error <- if (nb_na_error){
        renderText({validate("ERROR: only one \"NA\" value is acceptable")})
      } else {
        NULL
      }
    })

    # Read data
    p_data <- readRDS(system.file("extdata",
                                  "df_precomputed_datasets.rds",
                                  package = "CyTOFpower"))

    # Plot curve
    if ( input$p_nb_donors == "NA" )  { # If no donor
      p_data_filtered <- dplyr::filter(p_data,
                                       .data$rho == input$p_fc &
                                         .data$model == input$p_modelcheckGroup &
                                         .data$nb_cell_per_sample == input$p_nb_cells &
                                         .data$subject_effect == input$p_subeff &
                                         .data$total_nb_markers == input$p_total_nb_markers &
                                         .data$mu0 == input$p_mu0 &
                                         .data$dispersion == input$p_dispersion)
      output$p_plot_pwr_nbdonors <- renderPlot({
        ggplot2::ggplot(p_data_filtered, ggplot2::aes_string(x = "nb_donor", y = "power")) +
          ggplot2::geom_point() +
          ggplot2::geom_line() +
          ggplot2::scale_y_continuous(limits = c(0, 1)) +
          ggplot2::labs(title = "Plot of power by number of donors",
                        x = "Number of donors", y = "Power") +
          ggplot2::theme_bw()
      })
    } else if ( input$p_nb_cells == "NA" ) { # If no number of cells
      p_data_filtered <- dplyr::filter(p_data,
                                       .data$rho == input$p_fc &
                                         .data$model == input$p_modelcheckGroup &
                                         .data$nb_donor == input$p_nb_donors &
                                         .data$subject_effect == input$p_subeff &
                                         .data$total_nb_markers == input$p_total_nb_markers &
                                         .data$mu0 == input$p_mu0 &
                                         .data$dispersion == input$p_dispersion)
      output$p_plot_pwr_nbcells <- renderPlot({
        ggplot2::ggplot(p_data_filtered, ggplot2::aes_string(x = "nb_cell_per_sample", y = "power")) +
          ggplot2::geom_point() +
          ggplot2::geom_line() +
          ggplot2::scale_y_continuous(limits = c(0, 1)) +
          ggplot2::labs(title = "Plot of power by number of cells",
                        x = "Number of cells per sample", y = "Power") +
          ggplot2::theme_bw()
      })
    } else if ( input$p_subeff == "NA" )  { # If no subject effect
      p_data_filtered <- dplyr::filter(p_data,
                                       .data$rho == input$p_fc &
                                         .data$model == input$p_modelcheckGroup &
                                         .data$nb_cell_per_sample == input$p_nb_cells &
                                         .data$nb_donor == input$p_nb_donors &
                                         .data$total_nb_markers == input$p_total_nb_markers &
                                         .data$mu0 == input$p_mu0 &
                                         .data$dispersion == input$p_dispersion)
      output$p_plot_pwr_subject_effect <- renderPlot({
        ggplot2::ggplot(p_data_filtered, ggplot2::aes_string(x = "subject_effect", y = "power")) +
          ggplot2::geom_point() +
          ggplot2::geom_line() +
          ggplot2::scale_y_continuous(limits = c(0, 1)) +
          ggplot2::labs(title = "Plot of power by subject effect",
                        x = "Subject Effect", y = "Power") +
          ggplot2::theme_bw()
      })
    } else if ( input$p_total_nb_markers == "NA" )  { # If no total number of markers
      p_data_filtered <- dplyr::filter(p_data,
                                       .data$rho == input$p_fc &
                                         .data$model == input$p_modelcheckGroup &
                                         .data$nb_cell_per_sample == input$p_nb_cells &
                                         .data$subject_effect == input$p_subeff &
                                         .data$nb_donor == input$p_nb_donors &
                                         .data$mu0 == input$p_mu0 &
                                         .data$dispersion == input$p_dispersion)
      output$p_plot_pwr_total_nb_markers <- renderPlot({
        ggplot2::ggplot(p_data_filtered, ggplot2::aes_string(x = "total_nb_markers", y = "power")) +
          ggplot2::geom_point() +
          ggplot2::geom_line() +
          ggplot2::scale_y_continuous(limits = c(0, 1)) +
          ggplot2::labs(title = "Plot of power by the total number of markers",
                        x = "Total number of markers", y = "Power") +
          ggplot2::theme_bw()
      })
    } else if ( input$p_mu0 == "NA" )  { # If no mu0
      p_data_filtered <- dplyr::filter(p_data,
                                       .data$rho == input$p_fc &
                                         .data$model == input$p_modelcheckGroup &
                                         .data$nb_cell_per_sample == input$p_nb_cells &
                                         .data$subject_effect == input$p_subeff &
                                         .data$nb_donor == input$p_nb_donors &
                                         .data$total_nb_markers == input$p_total_nb_markers &
                                         .data$dispersion == input$p_dispersion)
      output$p_plot_pwr_mu0 <- renderPlot({
        ggplot2::ggplot(p_data_filtered, ggplot2::aes_string(x = "mu0", y = "power")) +
          ggplot2::geom_point() +
          ggplot2::geom_line() +
          ggplot2::scale_y_continuous(limits = c(0, 1)) +
          ggplot2::labs(title = "Plot of power by NB marker mean",
                        x = "Mean mu_0", y = "Power") +
          ggplot2::theme_bw()
      })
    } else if ( input$p_dispersion == "NA" )  { # If no dispersion
      p_data_filtered <- dplyr::filter(p_data,
                                       .data$rho == input$p_fc &
                                         .data$model == input$p_modelcheckGroup &
                                         .data$nb_cell_per_sample == input$p_nb_cells &
                                         .data$subject_effect == input$p_subeff &
                                         .data$nb_donor == input$p_nb_donors &
                                         .data$total_nb_markers == input$p_total_nb_markers &
                                         .data$mu0 == input$p_mu0)
      output$p_plot_pwr_dispersion <- renderPlot({
        ggplot2::ggplot(p_data_filtered, ggplot2::aes_string(x = "dispersion", y = "power")) +
          ggplot2::geom_point() +
          ggplot2::geom_line() +
          ggplot2::scale_y_continuous(limits = c(0, 1)) +
          ggplot2::labs(title = "Plot of power by NB marker dispersion",
                        x = "Dispersion", y = "Power") +
          ggplot2::theme_bw()
      })
    } else {
      # Display value
      p_data_filtered <- dplyr::filter(p_data,
                                       .data$rho == input$p_fc &
                                         .data$model == input$p_modelcheckGroup &
                                         .data$nb_cell_per_sample == input$p_nb_cells &
                                         .data$subject_effect == input$p_subeff &
                                         .data$nb_donor == input$p_nb_donors &
                                         .data$total_nb_markers == input$p_total_nb_markers &
                                         .data$mu0 == input$p_mu0 &
                                         .data$dispersion == input$p_dispersion)

      if(dim(p_data_filtered)[1] != 0){
        output$p_power <- renderText(
          paste0("Power = ", dplyr::pull(p_data_filtered, .data$power)))
      } else {
        output$p_power <- renderText("Selected combination of parameters not precomputed in current version.
                                   Please check back soon.")
      }

    }

  })

  # Personalized datasets
  # Warning on number of donors
  nb_donors_warning <- reactive({
    n <- input$nb_donors > 2
    shinyFeedback::feedbackWarning("nb_donors", !n, "At least 3 donors")
  })
  output$nb_donors_warning <- renderText(nb_donors_warning())

  # Matrix of parameters
  output$matrix <- renderUI({
    shinyMatrix::matrixInput(inputId = "param",
                             label = "Parameters per marker",
                             rows = list(
                               names = TRUE,
                               editableNames = TRUE),
                             cols = list(
                               names = TRUE,
                               editableNames = FALSE),
                             value = matrix(rep(c(1, 12, 3), input$nb_tot_markers),
                                            ncol = 3,
                                            byrow = TRUE,
                                            dimnames = list(c(paste0("m_", seq_len(input$nb_tot_markers))),
                                                            c("Fold Change", "Mean", "Dispersion")))
    )
  })

  # Show notification for no DE
  id <- NULL
  observeEvent(input$param,
               {
                 removeNotification(id)
                 fc <- any(input$param[,1] != "1")
                 if (!fc) {
                   id <<- showNotification("Please provide at least one DE marker (FC != 1)",
                                           duration = NULL,
                                           type = "error")
                 } else {
                   removeNotification(id)
                   id <<- NULL
                 }
               })

  # Once the goButton is activated
  observeEvent(input$goButton,
               {
                 # Extract matrix of parameters informations
                 df_param <- tibble::rownames_to_column(as.data.frame(input$param),
                                                        var = "marker_name")
                 colnames(df_param) <- c("marker_name", "rho", "mu0", "disp")

                 # Display a summary of the selected parameters
                 output$title_selected_var <- renderText({
                   paste("Selected parameters:", sep = "\n")
                 })
                 # Selected parameters description
                 output$selected_var <- renderUI({
                   # input$goButton
                   isolate({
                     # Introduction sentence
                     str_intro <- paste("For this simulation, you have selected
                                        the following parameters:", sep = "\n")
                     # Number of donors
                     str_nbdonor <- paste("Number of donors: ", input$nb_donors)
                     # Subject effect
                     str_subeff <- paste("Subject effect: ", input$subeff)
                     # Number of cells per sample
                     str_nbcells <- paste("Number of cells per sample: ",
                                          input$nb_cells)
                     # Total number of markers
                     str_totnbmarker <- paste("Total number of markers: ", dim(df_param)[1])
                     # Fold change
                     str_rho <- paste("Fold change of the marker(s): ", paste0(df_param$rho, collapse = "; "))
                     # Mu0
                     str_mu0 <- paste("Mean of the marker(s): ", paste0(df_param$mu0, collapse = "; "))
                     # Dispersion
                     str_disp <- paste("Dispersion of the marker(s): ", paste0(df_param$disp, collapse = "; "))
                     # Model to run
                     col_modelcheckGroup <- paste(input$modelcheckGroup, collapse = ", ")
                     str_models <- paste("Model(s) to run: ", col_modelcheckGroup)
                     # Number of simulation
                     str_sim <- paste("Number of simulation (s): ", input$nb_sim)

                     HTML(paste(str_intro, str_nbdonor,
                                str_subeff, str_nbcells,
                                str_totnbmarker,
                                # str_nbDEmarker,
                                str_rho, str_mu0, str_disp, str_models,
                                str_sim,
                                sep = '<br/>'))
                   })
                 })

                 # Generate the data
                 withProgress(message = 'Generating data', value = 0, {
                   ls_variation <- lapply(seq_len(input$nb_tot_markers), function(i){
                     data.frame(
                       "marker_name" = df_param[i, "marker_name"],
                       "mu0" = as.numeric(df_param[i, "mu0"]),
                       "dispersion" = as.numeric(df_param[i, "disp"]),
                       "subject_effect" = input$subeff,
                       "nb_donor" = input$nb_donors,
                       "nb_cell_per_sample" = input$nb_cells,
                       "rho" = as.numeric(df_param[i, "rho"]))
                   })
                   # Pipeline
                   ls_res <- lapply(seq_len(input$nb_sim), function(sim_id){
                     # (1) generate a single dataset
                     sim_data <- function_apply_onesimulation_withmarkerinfo(ls_variation)
                     # (2) apply methods
                     res_mod <- function_apply_modelcomputations_modelchoice(
                       list_combined_output = sim_data,
                       model = input$modelcheckGroup)
                     # (3) store results and discard data
                     # Observed variance/effect size
                     # Merge counts data
                     raw_data <- cbind(sim_data$ls_mock_raw_data, "i" = sim_id)
                     # Long format
                     raw_data_lg <- tidyr::pivot_longer(raw_data,
                                                        cols = -c("i",
                                                                  "group_id",
                                                                  "donor_id",
                                                                  "sample_id"),
                                                        names_to = "markers",
                                                        values_to = "raw_intensity")
                     # Variance and effect size
                     obs_variance <- compute_variance(raw_data_lg)
                     obs_effectsize <- compute_effectsize(raw_data_lg)
                     # Discard
                     rm(sim_data)
                     # Return
                     return(list("res_models" = res_mod,
                                 "obs_variance" = obs_variance,
                                 "obs_effectsize" = obs_effectsize))
                     # (4) repeat
                   })
                 })

                 # Combine results
                 # Models
                 df_res_models <- do.call("bind_rows", list(lapply(ls_res, function(x){
                   x[["res_models"]]
                 }), .id = "i"))
                 # Variance
                 df_obs_variance_persim <- do.call("bind_rows", list(lapply(ls_res, function(x){
                   x[["obs_variance"]]
                 }), .id = "i"))
                 ## mean
                 df_obs_variance <- df_obs_variance_persim %>%
                   dplyr::group_by(.data$donor_id) %>%
                   dplyr::summarize(variance = round(mean(.data$variance), digits = 2))
                 # Effect size
                 df_obs_effectsize_persim <- do.call("bind_rows", list(lapply(ls_res, function(x){
                   x[["obs_effectsize"]]
                 }), .id = "i"))
                 ## Mean
                 df_obs_effectsize <- df_obs_effectsize_persim %>%
                   dplyr::group_by(.data$markers) %>%
                   dplyr::summarize(effect_size = round(mean(.data$effect_size), digits = 1),
                                    observed_FC = round(mean(.data$observed_FC), digits = 1))

                 # Name of DE(s) markers
                 df_var <- dplyr::bind_rows(ls_variation)
                 df_var_DE <- dplyr::filter(df_var, .data$rho != 1)
                 output$DE_names <- renderText(
                   paste("Name(s) of the DE markers:", paste(df_var_DE$marker_name, collapse = "; "))
                 )


                 # Output
                 output$title_var <- renderText(paste("Observed sample variance (mean across simulations)"))
                 output$tab_obs_variance <- DT::renderDataTable({df_obs_variance},
                                                                options = list(pageLength = 5))
                 output$title_effsize <- renderText(paste("Observed Cohen's effect size"))
                 output$tab_obs_effectsize <- DT::renderDataTable({df_obs_effectsize},
                                                                  options = list(pageLength = 5))
                 output$results_models <- DT::renderDataTable({df_res_models})

                 # Compute power
                 withProgress(message = "Compute power", value = 0, {
                   pwr_values <- compute_pwr(df_res_models)
                 })
                 colnames(pwr_values) <- c("model", "markers", "power")
                 output$title_power <- renderText(paste("Power"))
                 output$results_pwr_values <- DT::renderDataTable({
                   pwr_values[,c("model", "markers", "power")]})

                 # Effect size - power
                 ## Combine
                 pwr_eff <- dplyr::left_join(pwr_values, df_obs_effectsize,
                                             by = "markers")
                 ## Plot
                 if(length(input$modelcheckGroup) > 1){
                   output$plot_pwr_eff <- renderPlot({
                     ggplot2::ggplot(pwr_eff, ggplot2::aes_string(x = "effect_size",
                                                                  y = "power",
                                                                  col = "model")) +
                       ggplot2::geom_point(size = 2,
                                           position = ggplot2::position_jitter(width = 0.01,
                                                                               height = 0.01)) +
                       ggplot2::ylim(0, 1.3) +
                       ggplot2::labs(title="Plot of power by effect size",
                                     x ="Cohen effect size", y = "Power") +
                       ggplot2::theme_bw()
                   })
                 } else{
                   output$plot_pwr_eff <- renderPlot({
                     ggplot2::ggplot(pwr_eff, ggplot2::aes_string(x = "effect_size",
                                                                  y = "power",
                                                                  col = "model")) +
                       ggplot2::geom_point(size = 2) +
                       ggplot2::ylim(0, 1) +
                       ggplot2::labs(title="Plot of power by effect size",
                                     x ="Cohen effect size", y = "Power") +
                       ggplot2::theme_bw()
                   })
                 }

                 # Wide format
                 pwr_eff_w <- tidyr::pivot_wider(data = pwr_eff,
                                                 id_cols = c("markers",
                                                             "effect_size",
                                                             "observed_FC"),
                                                 names_from = "model",
                                                 values_from = "power")
                 ## Add non-DE marker
                 nonDE_obs_effectsize <- df_obs_effectsize[!(df_obs_effectsize$markers %in% pwr_eff_w$markers),]
                 col_to_add <- colnames(pwr_eff_w)[!(colnames(pwr_eff_w) %in% colnames(nonDE_obs_effectsize))]
                 nonDE_obs_effectsize[,col_to_add] <- NA
                 pwr_eff_w_nonDE <- rbind(pwr_eff_w, nonDE_obs_effectsize)
                 output$results_pwr_with_effsize <- DT::renderDataTable(
                   pwr_eff_w_nonDE,
                   server = FALSE)
               }
  )

}

#' Compute power
#'
#' @details Compute the power based on the model values.
#'
#' @param model_values data.frame, output of run_models().
#' @param alpha numeric, significance level.
#'
#' @return numeric, power.
#'
#' @keywords internal
compute_pwr <- function(model_values,
                        alpha = 0.05){
  model_values %>%
    dplyr::filter(.data$truth == 1) %>% # Filter the values with a true fold change
    dplyr::group_by(.data$model, .data$marker_id) %>% # Group by models and marker ID
    dplyr::summarize(power = mean(.data$p_adj < alpha)) # Compute the power
}

#' Compute variance
#'
#' @details Compute the observed variance in the data.
#'
#' @param raw_data_lg data.frame, cells values in long format.
#'
#' @return numeric, observed variance mean.
#'
#' @keywords internal
compute_variance <- function(raw_data_lg){
  # Sample variance
  obs_sample_variance <- raw_data_lg %>%
    dplyr::group_by(.data$i, .data$donor_id) %>%
    dplyr::summarize(variance = stats::var(.data$raw_intensity))
  # Mean of the sample variance
  mean_obs_sample_variance <- obs_sample_variance %>%
    dplyr::group_by(.data$donor_id) %>%
    dplyr::summarize(variance = round(mean(.data$variance), digits = 2))

  return(mean_obs_sample_variance)
}

#' Compute effect size
#'
#' @details Compute observed Cohen's effect size and observed fold change.
#'
#' @param raw_data_lg data.frame, cells values in long format.
#'
#' @return data.frame, Cohen's effect size and fold change that were observed
#' in the data for each marker.
#'
#' @keywords internal
compute_effectsize <- function(raw_data_lg){
  # Effect size
  ## Mean
  mean_raw_data_summary_1 <- raw_data_lg %>%
    dplyr::group_by(.data$group_id, .data$markers) %>%
    dplyr::summarize(mean = mean(.data$raw_intensity))
  ## Mean difference
  mean_raw_data_summary_1_wd <- mean_raw_data_summary_1 %>%
    tidyr::pivot_wider(id_cols = markers,
                       names_from = group_id,
                       values_from = mean)
  mean_diff_raw_data_summary_1_wd <- dplyr::reframe(mean_raw_data_summary_1_wd,
                                                      mean_diff = .data$B - .data$A,
                                                      .data$markers)
  ## Standard deviation
  sd_raw_data_summary_1 <- raw_data_lg %>%
    dplyr::group_by(.data$i, .data$markers)  %>%
    dplyr::summarize(standard_deviation = stats::sd(.data$raw_intensity))
  sd_mean_raw_data_summary_1 <- sd_raw_data_summary_1 %>%
    dplyr::group_by(.data$markers)  %>%
    dplyr::summarize(mean_sd = mean(.data$standard_deviation))
  ## Combine
  cb_raw_data <- dplyr::left_join(mean_diff_raw_data_summary_1_wd, sd_mean_raw_data_summary_1)
  eff_size_raw_data <- dplyr::reframe(cb_raw_data,
                                        effect_size = round(.data$mean_diff / .data$mean_sd, digits = 1),
                                        .data$markers)

  # Fold Change
  obs_fc <- dplyr::reframe(mean_raw_data_summary_1_wd,
                             observed_FC = round(.data$B / .data$A, digits = 1),
                             .data$markers)

  # Return
  res <- dplyr::left_join(eff_size_raw_data, obs_fc)
  return(res[,c("markers", "effect_size", "observed_FC")])
}

# Create list of parameters combination for 3 markers
variation <- list(data.frame("marker_name" = "m1",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3),
                  data.frame("marker_name" = "m2",
                             "nb_donor" = 3,
                             "rho" = 1.1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3),
                  data.frame("marker_name" = "m3",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3))
# Create a mock dataset
df_exp_info <- data.frame("group_id" = as.factor(rep(c("A", "B"), times = 3)),
                          "donor_id" = rep(c("donor_1", "donor_2", "donor_3"), each = 2),
                          "sample_id" = paste0("sample_", c(1,4,2,5,3,6)))
df_exp_info_rep <- df_exp_info[rep(seq_len(nrow(df_exp_info)), each = 3), ]
df_raw_data <- data.frame(df_exp_info,
                          "m1" = c(14, 4, 9, 17, 10, 9, 4, 2, 5, 2, 14, 1, 11, 4, 10, 9, 22, 16),
                          "m2" = c(10, 5, 16, 12, 12, 13, 10, 3, 11, 6, 5, 6, 6, 5, 16, 8, 17, 8),
                          "m3" = c(8, 5, 6, 3, 6, 10, 7, 2, 12, 7, 4, 14, 12, 24, 5, 12, 20, 20))
trans_data <- asinh(df_raw_data[, c("m1", "m2", "m3")]/5)
df_trans_data <- data.frame(df_exp_info,
                            trans_data)
ls_3markers <- list("variation" = bind_rows(variation),
                    "df_info" = tibble::as_tibble(df_exp_info),
                    "DE_markers_names" = "m2",
                    "ls_mock_data" = tibble::as_tibble(df_trans_data),
                    "ls_mock_raw_data" = tibble::as_tibble(df_raw_data))

# Test compute_pwr() ---------------------------------------------------------------------------

# Run model - cytoglmm
res_cytoglmm <- lapply(seq_len(3), function(sim_id){
  res_mod <- function_apply_modelcomputations_modelchoice(list_combined_output = ls_3markers,
                                                          model = "cytoglmm")
})
# Concatenate
df_res_models <- bind_rows(res_cytoglmm, .id = "i")

# Test
test_that("Compute the power", {
  # Set seed
  set.seed(123)
  # Compute power
  pwr <- compute_pwr(df_res_models)

  # Test output
  # Is it a list?
  expect_type(pwr, "list")
  # Does it have the right structure?
  expect_identical(names(pwr),
                   c("model", "marker_id", "power"))
})

# Test compute_variance() ---------------------------------------------------------------------------

# Variance
raw_data_lg <- lapply(seq_len(3), function(sim_id){
  # Generate a single dataset
  sim_data <- function_apply_onesimulation_withmarkerinfo(variation)
  # Observed variance/effect size
  # Merge counts data
  raw_data <- cbind(sim_data$ls_mock_raw_data, "i" = sim_id)
  # Long format
  tidyr::pivot_longer(raw_data,
                      cols = -c("i", "group_id", "donor_id", "sample_id"),
                      names_to = "markers",
                      values_to = "raw_intensity")
})
# Concatenate
df_obs <- bind_rows(raw_data_lg, .id = "i")

# Test
test_that("Compute variance", {
  # Set seed
  set.seed(123)
  # Variance
  obs_variance <- compute_variance(df_obs)

  # Test output
  # Is it a list?
  expect_type(obs_variance, "list")
  # Does it have the right structure?
  expect_identical(names(obs_variance),
                   c("donor_id", "variance"))
})

# Test compute_effectsize() ---------------------------------------------------------------------------

# Test
test_that("Compute variance", {
  # Set seed
  set.seed(123)
  # Effect size
  obs_effectsize <- compute_effectsize(df_obs)

  # Test output
  # Is it a list?
  expect_type(obs_effectsize, "list")
  # Does it have the right structure?
  expect_identical(names(obs_effectsize),
                   c("markers", "effect_size", "observed_FC"))
})

# Functions to generate the data

### Helper functions ###

#' Data paired.
#'
#' @details Function to check if the data is paired.
#'
#' @param data data.frame, experimental information containing (sample IDS,
#' donor IDs).
#'
#' @return logical, TRUE is the data are paired - FALSE if the data are not paired
#'
#' @keywords internal
function_is_data_paired <- function(data){
  # Number of samples
  nb_samples <- length(unique(data$sample_id))
  # Number of donors
  nb_donors <- length(unique(data$donor_id))
  # Are the data paired?
  if(nb_samples == nb_donors){
    message("The dataset is not paired: please use bootstrap GLMM model")
    are_paired_check <- "FALSE"
  } else {
    message("Your dataset is paired, you can used the GLMM model or diffcyt package")
    are_paired_check <- "TRUE"
  }

  return(are_paired_check)
}


#' Check on the number of DE markers.
#'
#' @details Function to check that number of DE markers greater than number of
#' markers.
#'
#' @param nb_markers numeric, total number of markers.
#' @param nb_DEmarker numeric, number of differentially expressed markers.
#'
#' @return error message if the number of DE markers is greater than the total
#' number of markers.
#'
#' @keywords internal
function_DEmarkers_sup_nbmarkers <- function(nb_markers, nb_DEmarker){
  if(nb_markers < nb_DEmarker){
    stop("Number of markers is not greater than number of differentially expressed makers")
  }
}

#' Number of markers greater than 2.
#'
#' @details Function to check that the number of markers is greater than 2.
#'
#' @param nb_marker numeric, total number of markers.
#'
#' @return error message if the total number of markers is lower than 3.
#'
#' @keywords internal
function_check_nbmarkers <- function(nb_marker){
  if(nb_marker < 3){
    stop("Number of markers should be greater than 2")
  }
}

#' Number of DE markers greater than 1.
#'
#' @details Function to check that the number of DE markers is greater than 1.
#'
#' @param nb_DEmarker numeric, number of differentially expressed markers.
#'
#' @return error message
#'
#' @keywords internal
function_check_nbDEmarkers <- function(nb_DEmarker){
  if(nb_DEmarker < 1){
    stop("Number of markers should be greater than 0")
  }
}

#' arcsinh transformation.
#'
#' @details Function to transform the data with the recommended transformation
#' for cyTOF data: arcsinh with cofactor equals to 5.
#'
#' @param data data.frame, cell values to transform.
#' @param cofactor numeric, co-factor used in the arcsinh (by default
#' cofactor = 5).
#'
#' @return data.frame of transformed data.
#'
#' @keywords internal
function_to_transform_data <- function(data, cofactor = 5) {
  asinh(data/cofactor)
}

### Function to create information ###

#' Extract marker names.
#'
#' @details Function to extract the marker names.
#'
#' @param mock_dataset data.frame, containing the cell values for each marker.
#'
#' @return vector of marker names.
#'
#' @keywords internal
function_extract_marker_names <- function(mock_dataset){
  setdiff(colnames(mock_dataset), c("group_id", "donor_id", "sample_id"))
}

#' Generate name of the DE markers.
#'
#' @details Function to generate the name of the DE markers.
#'
#' @param total_nb_marker numeric, total number of markers.
#' @param nb_DE_marker numeric, number of DE markers.
#'
#' @return vactor of marker names.
#'
#' @keywords internal
function_names_DE_markers <- function(total_nb_marker, nb_DE_marker){
  # Name
  paste("Marker", seq_len(nb_DE_marker), sep = "")
}

### Function to create data ###

#' Compute simulated cell values for one marker with markers NB informations
#'
#' @details Function to generate value for one marker with a mean and dispersion
#' specified for the negative binomiale.
#'
#' @param marker_name character, name of the marker.
#' @param nb_donor numeric, number of donors.
#' @param rho numeric, fold change.
#' @param mu0 numeric, general donor mean from which the individual mu0i will
#' be drawn.
#' @param dispersion numeric, dispersion of the markers.
#' @param subject_effect numeric, standard deviation for the normal distribution
#' from which the donor's means will be drawn (by default subject_effect = 0.01).
#' @param nb_cell_per_sample numeric, number of cells per sample (by default
#' nb_cell_per_sample = 500).
#'
#' @return data.frame of cell values.
#'
#' @keywords internal
function_value_onemarker <- function(marker_name,
                                     mu0,
                                     dispersion,
                                     subject_effect,
                                     nb_donor,
                                     nb_cell_per_sample,
                                     rho = 1){

  # Create a data.frame for experiment info
  df_experiment_info_paired <-
    data.frame(donor_id = rep(paste0("donor_", seq_len(nb_donor)), 2),
               group_id = rep(c("A", "B"), each=nb_donor),
               sample_id = paste("sample_", seq_len(nb_donor*2), sep = ""))


  # Compute mu0i for each donor
  ## Shape
  k <- mu0^2 / subject_effect^2
  ## Scale
  theta <- subject_effect^2 / mu0
  ## mu0i
  mu0i <- stats::rgamma(nb_donor, shape = k, scale = theta)
  # Compute mu_1 (mean DE marker) based on donor mean
  mu_1i <- rho*mu0i

  # Per donor
  raw_mock_dataset_expdesign <- lapply(seq_len(nb_donor), function(i_donor){
    # Cell values
    ## Condition A
    condition_A <- matrix(stats::rnbinom(n = nb_cell_per_sample, mu = mu0i[i_donor],
                                  size = dispersion))
    # Condition B
    condition_B <- matrix(stats::rnbinom(n = nb_cell_per_sample, mu = mu_1i[i_donor],
                                  size = dispersion))

    # Combine matrices
    combined_matrices <- rbind(condition_A, condition_B)
    # Raw intensity values
    combined_matrices_raw <- as.data.frame(combined_matrices)
    # Markers names
    colnames(combined_matrices_raw) <- "count" #marker_name
    # Add the conditions
    combined_matrices_raw$"group_id" <- rep(c("A", "B"), each = nb_cell_per_sample)
    # Add the donor ID
    combined_matrices_raw$"donor_id" <- unique(df_experiment_info_paired$donor_id)[i_donor]
    # Add sample ID
    combined_matrices_raw_expdesign <- dplyr::left_join(combined_matrices_raw,
                                                        df_experiment_info_paired,
                                                        by = c("donor_id", "group_id"))
    return(combined_matrices_raw_expdesign)
  })
  raw_mock_dataset_expdesign <- dplyr::bind_rows(raw_mock_dataset_expdesign)
  raw_mock_dataset_expdesign$group_id <- as.factor(raw_mock_dataset_expdesign$group_id)
  raw_mock_dataset_expdesign$marker_name <- marker_name

  # Return
  return(raw_mock_dataset_expdesign)
}

#' Compute simulated cell values for one simulation with markers NB information.
#'
#' @details Function to compute the simulated cell values using a combination of
#' variable parameters, when we have prior information about the markers
#' distribution parameters (mean and dispersion of the negative binomial).
#'
#' @param variation list, list of data.frames containing the different variable
#' input paramaters to generate the data:
#'     - marker_name: name of the marker (character);
#'     - nb_donor: number of donors;
#'     - rho: fold change;
#'     - subject_effect: standard deviation for the normal distribution from
#'     which the donor's means will be drawn;
#'     - mu0: mean of the negative binomial for the gamma distribution from
#'     which the means of the different donor will be drawn;
#'     - dispersion: dispersion of the negative binomial from
#'     which the DE marker's cell values will be drawn;
#'     - nb_cell_per_sample: number of cells per sample.
#'
#' @return list with 4 slots:
#'     - df_info: data.frame of experimental information;
#'     - DEmarkers_names: vector of DE marker names;
#'     - raw_data: data.frame of raw cell values;
#'     - data: data.frame of transformed cell values.
#'
#' @keywords internal
function_create_mock_dataset_withmarkerinfo <- function(variation){
  # Generate values for all markers
  ls_raw_mock_dataset_expdesign <- lapply(variation, function(onemarker) {
    function_value_onemarker(marker_name = onemarker$marker_name,
                             mu0 = onemarker$mu0,
                             dispersion = onemarker$dispersion,
                             subject_effect = onemarker$subject_effect,
                             nb_donor = onemarker$nb_donor,
                             nb_cell_per_sample = onemarker$nb_cell_per_sample,
                             rho = onemarker$rho)
  })
  # Merge markers values
  raw_mock_dataset_expdesign_w <- dplyr::bind_rows(ls_raw_mock_dataset_expdesign)
  # Transform data
  mock_dataset <- function_to_transform_data(raw_mock_dataset_expdesign_w$count)
  mock_dataset_expdesign_w <- cbind("transformed_values" = mock_dataset,
                                  raw_mock_dataset_expdesign_w)
  # Create long formats
  raw_mock_dataset_expdesign <- raw_mock_dataset_expdesign_w %>%
    dplyr::group_by(marker_name) %>%
    dplyr::mutate(rn = dplyr::row_number()) %>% # recreated unique identifier column
    tidyr::pivot_wider(names_from = marker_name, values_from = count)
  raw_mock_dataset_expdesign$rn <- NULL
  mock_dataset_expdesign <- mock_dataset_expdesign_w %>%
    dplyr::select(-c(count)) %>%
    dplyr::group_by(marker_name) %>%
    dplyr::mutate(rn = dplyr::row_number()) %>% # recreated unique identifier column
    tidyr::pivot_wider(names_from = marker_name,
                       values_from = transformed_values)
  mock_dataset_expdesign$rn <- NULL
  # Which markers are DE?
  df_var <- dplyr::bind_rows(variation)
  df_onlyDE <- dplyr::filter(df_var, rho != 1)
  DEmarkers_names <- as.vector(df_onlyDE$marker_name)

  # Create a data.frame for experiment info
  df_experiment_info_paired <-
    unique(dplyr::select(mock_dataset_expdesign,
                         c("group_id", "donor_id", "sample_id")))

  # Create list of simulated data
  return(list("df_info" = df_experiment_info_paired,
              "DEmarkers_names" = DEmarkers_names,
              "raw_data" = raw_mock_dataset_expdesign,
              "data" = mock_dataset_expdesign))
}

### Wrapper functions ###

#' One simulation with markers NB information.
#'
#' @details Apply one simulation for a given parameter combination
#' number times (iterations), when we have prior information about the markers
#' distribution parameters (mean and dispersion of the negative binomial).
#'
#' @param variation list, list of list containing the different input
#' parameter variations @describeIn function_create_mock_dataset_withmarkerinfo.
#'
#' @return list of simulated data. Each list member contains 5 slots:
#'     - variation: the variation of input paramaters which has been used in input;
#'     - df_info: experimental information (donor IDs, group IDs, samples IDs);
#'     - DE_markers_names: name of the differentially expressed markers;
#'     - ls_mock_data: list of data.frames, each data.frame being one simulation of
#'     the cell values using the input parameters provided (list is length nb_sim).
#'
#' @keywords internal
function_apply_onesimulation_withmarkerinfo <- function(variation) {

  print(variation)
  # Apply one simulation
  output <- function_create_mock_dataset_withmarkerinfo(variation = variation)
  # Extract the experimental info which are unique for all simulation of this iteration
  df_info <- output$df_info
  # Extract mock data
  list_df_data <- output$data
  # Extract mock raw data
  list_df_raw_data <- output$raw_data
  # Extract the name(s) of the DE markers which are unique for all simulation of this iteration
  DEmarkers_names <- output$DEmarkers_names
  # Combine with the experimental info, with mock data and variation
  list_combined_output <- list("variation" = dplyr::bind_rows(variation),
                               "df_info" = df_info,
                               "DE_markers_names" = DEmarkers_names,
                               "ls_mock_data" = list_df_data,
                               "ls_mock_raw_data" = list_df_raw_data)

  # return
  return(list_combined_output)
}

# Test functions to generate the data

# test function_value_onemarker() ---------------------------------------------------------------------------

# Create data.frame to compare
df_one_marker  <- data.frame("count" = c(13, 4, 10, 18, 10, 6),
                             "group_id" = as.factor(rep(c("A", "B"), times = 3)),
                             "donor_id" = rep(c("donor_1", "donor_2", "donor_3"), each = 2),
                             "sample_id" = paste0("sample_", c(1,4,2,5,3,6)),
                             "marker_name" = "m1")

# Test data generation for one marker
test_that("Data generated for one marker", {
  # Set seed
  set.seed(123)
  # Generate data with function
  df_to_test <- function_value_onemarker("marker_name" = "m1",
                                         "mu0" = 10,
                                         "dispersion" = 2,
                                         "subject_effect" = 0.1,
                                         "nb_donor" = 3,
                                         "nb_cell_per_sample" = 1,
                                         "rho" = 1)
  # Test
  expect_equal(df_one_marker, df_to_test)
})

# test function_create_mock_dataset_withmarkerinfo() ---------------------------------------------------------------------------

# Create list to compare
df_exp_info <- data.frame("group_id" = as.factor(rep(c("A", "B"), times = 3)),
                          "donor_id" = rep(c("donor_1", "donor_2", "donor_3"), each = 2),
                          "sample_id" = paste0("sample_", c(1,4,2,5,3,6)))
df_raw_data <- data.frame(df_exp_info,
                          "m1" = c(14, 4, 9, 17, 10, 9),
                          "m2" = c(3, 4, 5, 14, 3, 10))
trans_data <- asinh(df_raw_data[, c("m1", "m2")]/5)
df_trans_data <- data.frame(df_exp_info,
                            trans_data)
ls_multi_marker <- list("df_info" = tibble::as_tibble(df_exp_info),
                        "DEmarkers_names" = "m2",
                        "raw_data" = tibble::as_tibble(df_raw_data),
                        "data" = tibble::as_tibble(df_trans_data))
# Create list of parameters combination for 2 markers
variation <- list(data.frame("marker_name" = "m1",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 1),
                  data.frame("marker_name" = "m2",
                             "nb_donor" = 3,
                             "rho" = 1.1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 1))

# Test data generated for multiple markers
test_that("Data generated for multiple marker", {
  # Set seed
  set.seed(123)
  # Generate data with function
  ls_to_test <- function_create_mock_dataset_withmarkerinfo(variation)
  # Test
  expect_equal(ls_to_test, ls_multi_marker)
})

# test function_create_mock_dataset_withmarkerinfo() ---------------------------------------------------------------------------

# Create list to compare
# Reusing data generated to test function_create_mock_dataset_withmarkerinfo()
ls_multi_sim <- list("variation" = bind_rows(variation),
                     "df_info" = tibble::as_tibble(df_exp_info),
                     "DE_markers_names" = "m2",
                     "ls_mock_data" = tibble::as_tibble(df_trans_data),
                     "ls_mock_raw_data" = tibble::as_tibble(df_raw_data))

# Test data generated for multiple markers, for multiple simulation
test_that("Data generated for multiple simulations", {
  # Set set
  set.seed(123)
  # Generate data with function
  ls_to_test <- function_apply_onesimulation_withmarkerinfo(variation)
  # Test
  expect_equal(ls_to_test, ls_multi_sim)
})

#' CyTOFpower: R-package to predict the power of a CyTOF experiment
#'
#' This package provides functions and a shiny app to predict the power of a
#' CyTOF experiment.
#'
#' @docType package
#' @name CyTOFpower
#'
#' @import methods
#' @import shiny
#'
#' @importFrom shinyjs useShinyjs
#' @importFrom shinyFeedback useShinyFeedback
#' @importFrom rlang .data
#' @importFrom magrittr "%>%"
#' @importFrom dplyr bind_rows
NULL

# UI
appUI <- fluidPage(
  # For warnings
  shinyFeedback::useShinyFeedback(),
  shinyjs::useShinyjs(),

  navbarPage("CyTOFpower",

             # Precomputed datasets
             tabPanel("Precomputed dataset",
                      "This panel allows to search a grid of parameters that have been
                      precomputed. The value NA displays a power curve for the different
                      values of this parameter.",
                      # Sidebar panel
                      sidebarLayout(
                        # Sidebar panel for inputs ----
                        sidebarPanel(

                          # Input: Select the number of donors ----
                          selectInput(inputId = "p_nb_donors",
                                      label = "Number of donors:",
                                      choices = list_param_precomupteddataset$nb_donor),
                          # textOutput("na_error"),

                          # Input: Select the subject effect ----
                          selectInput(inputId = "p_subeff",
                                      label = "Subject effect:",
                                      choices = list_param_precomupteddataset$subject_effect),

                          # Input: Select the number of cells per sample ----
                          selectInput(inputId = "p_nb_cells",
                                      label = "Number of cells per sample:",
                                      choices = list_param_precomupteddataset$nb_cell_per_sample),

                          # Input: Select the total number of markers ----
                          selectInput(inputId = "p_total_nb_markers",
                                      label = "Total number of markers:",
                                      choices = list_param_precomupteddataset$total_nb_markers),

                          # Input: Select the fold change
                          selectInput(inputId = "p_fc",
                                      label = "Marker's Fold Change (FC)",
                                      choice = c(1.1, 1.2, 1.3, 1.5, 1.8, 2.0, 3.0)),

                          # Input: Select the mu0 ----
                          selectInput(inputId = "p_mu0",
                                      label = "Mean:",
                                      choices = list_param_precomupteddataset$mu0),

                          # Input: Select the dispersion ----
                          selectInput(inputId = "p_dispersion",
                                      label = "Dispersion:",
                                      choices = list_param_precomupteddataset$dispersion),

                          # Input: Check box to choose which model to run ----
                          selectInput(inputId = "p_modelcheckGroup",
                                      label = "Models to run",
                                      choices = list("CytoGLMM - GLMM" = "cytoglmm",
                                                     "diffcyt - limma with fixed effect" = "testDS_limma_fixed",
                                                     "diffcyt - limma with random effect" = "testDS_limma_random",
                                                     "diffcyt - lme4" = "testDS_lmm")),

                          # Input: Action button to submit the parameters
                          actionButton(inputId = "p_goButton",
                                       label = "Get power"),

                          textOutput("na_error")


                        ),
                        # Main panel
                        mainPanel(
                          conditionalPanel("input.p_nb_donors == 'NA'",
                                           plotOutput("p_plot_pwr_nbdonors")
                          ),
                          conditionalPanel("input.p_nb_cells == 'NA'",
                                           plotOutput("p_plot_pwr_nbcells")
                          ),
                          conditionalPanel("input.p_subeff == 'NA'",
                                           plotOutput("p_plot_pwr_subject_effect")
                          ),
                          conditionalPanel("input.p_total_nb_markers == 'NA'",
                                           plotOutput("p_plot_pwr_total_nb_markers")
                          ),
                          conditionalPanel("input.p_mu0 == 'NA'",
                                           plotOutput("p_plot_pwr_mu0")
                          ),
                          conditionalPanel("input.p_dispersion == 'NA'",
                                           plotOutput("p_plot_pwr_dispersion")
                          ),
                          conditionalPanel("input.p_nb_donors != 'NA' &&
                                           input.p_nb_cells != 'NA' &&
                                           input.p_subeff != 'NA' &&
                                           input.p_total_nb_markers != 'NA' &&
                                           input.p_mu0 != 'NA' &&
                                           input.p_dispersion != 'NA'",
                                           textOutput(outputId = "p_power")
                          ))
                      )
             ),
             # Personalized datasets
             tabPanel("Personalized dataset",
                      "This panel allows to compute the power for a chosen set of
                      parameter. The data are generated on request and it takes some time
                      to get the results.",
                      # Sidebar panel
                      sidebarLayout(

                        # Sidebar panel for inputs ----
                        sidebarPanel(

                          # Input: Field to enter the number of donors ----
                          numericInput(inputId = "nb_donors",
                                       label = "Number of donors:",
                                       value = 10,
                                       min = 3),
                          textOutput("nb_donors_warning"),

                          # Input: Slider for the subject effect ----
                          sliderInput(inputId = "subeff",
                                      label = "Subject effect:",
                                      min = 0.01,
                                      max = 3,
                                      value = 0.5),

                          # Input: Field to enter the number of cells per sample ----
                          numericInput(inputId = "nb_cells",
                                       label = "Number of cells per sample:",
                                       value = 500,
                                       min = 10),

                          # Input: Slider for the number of markers ----
                          sliderInput(inputId = "nb_tot_markers",
                                      label = "Total number of markers:",
                                      min = 3,
                                      max = 50,
                                      value = 20),

                          uiOutput("matrix"),

                          # Input: Check box to choose which model to run ----
                          checkboxGroupInput(inputId = "modelcheckGroup",
                                             label = "Models to run",
                                             choices = list("CytoGLMM - GLMM" = "cytoglmm",
                                                            # "CytoGLMM - GLM with bootstrap" = "cytoglm",
                                                            "diffcyt - limma with fixed effect" = "testDS_limma_fixed",
                                                            "diffcyt - limma with random effect" = "testDS_limma_random",
                                                            "diffcyt - lme4" = "testDS_lmm"),
                                             selected = "cytoglmm"),

                          # Input: Field to enter the number of simulations ----
                          numericInput(inputId = "nb_sim",
                                       label = "Number of simulations for the set of selected parameters:",
                                       value = 10,
                                       min = 1,
                                       max = 100),

                          # Input: Action button to submit the paramaters
                          actionButton(inputId = "goButton",
                                       label = "Run simulation")
                        ),
                        # Main panel
                        mainPanel(

                          # Output: Tabset w/ plot, summary, and table ----
                          tabsetPanel(type = "tabs",
                                      tabPanel("Summary",
                                               h4(textOutput(outputId = "title_selected_var")),
                                               uiOutput(outputId = "selected_var"),
                                               textOutput(outputId = "DE_names")),

                                      tabPanel("Power",
                                               plotOutput(outputId = "plot_pwr_eff"),
                                               h4(textOutput(outputId = "title_power")),
                                               DT::dataTableOutput(outputId = "results_pwr_with_effsize")),

                                      tabPanel("Details",
                                               # Observed variance and effect size
                                               h4(textOutput(outputId = "title_var")),
                                               DT::dataTableOutput(outputId = "tab_obs_variance"),
                                               ## Results
                                               DT::dataTableOutput(outputId = "results_models"))
                          )
                        )

                      )
             )
  )

)

# Data for shiny interface
precomputed_data <- readRDS(system.file("extdata",
                                        "df_precomputed_datasets.rds",
                                        package = "CyTOFpower"))
list_param_precomupteddataset <-list(
  "nb_donor" = c(sort(unique(precomputed_data$nb_donor)), NA),
  "total_nb_markers" = c(sort(unique(precomputed_data$total_nb_markers)), NA),
  "nb_DEmarkers" = sort(unique(precomputed_data$nb_DEmarkers)),
  "subject_effect" = c(sort(unique(precomputed_data$subject_effect)), NA),
  "mu0" = c(sort(unique(precomputed_data$mu0)), NA),
  "dispersion" = c(sort(unique(precomputed_data$dispersion)), NA),
  "nb_cell_per_sample" = c(sort(unique(precomputed_data$nb_cell_per_sample)), NA)
)

#' Shiny app
#'
#' Interactive shiny app to predict the power of a CyTOF experiment.
#'
#' @return Interactive shiny app.
#' @examples
#' # Launch the shiny app
#' if (interactive()) {
#'   CyTOFpower()
#' }
#' @export
CyTOFpower <- function(){
  app <- shinyApp(ui = appUI, server = appServer)
  runApp(app)
}

# Functions to summarize results from the different models

#' Summarize data and results.
#'
#' @details Function to do a summary of the tested data and model's results
#'   for the CytoGLMM and diffcyt packages.
#'
#' @param summary_from_model list, output from the functions running the models.
#' @param package character, package used to run the test: "CytoGLMM" or "diffcyt".
#'
#' @return data.frame of results for each simulation.
#'
#' @keywords internal
function_summary_results_models <- function(summary_from_model, package){

  # Get package argument
  package <- match.arg(package, choices = c("CytoGLMM", "diffcyt"))

  # Rename colnames
  # if the cytoGLMM package has been used, the column name in the results table
  # is "protein_name"
  if(package == "CytoGLMM"){
    res_sum <- as.data.frame(summary_from_model$result_summary)
    colnames(res_sum) <- c("marker_id", "p_val", "p_adj")
  } else if(package =="diffcyt"){
    # if the diffcyt package has been used, the column name in the results table
    # is "marker_id"
    res_sum <- as.data.frame(summary_from_model$result_summary[,c("marker_id",
                                                                  "p_val",
                                                                  "p_adj")])
  }
  # Return
  return(as.data.frame(res_sum))
}

# Generation of the df_precomputed_datasets.txt file
#
# This file was generated using un-exported functions of the CyTOFpower package.
# Each set of parameter was generated as described below:

# A function regrouping the different steps of the pipeline was created:
fct_workflow <- function(nb_sim, ls_variation, modelcheckGroup){
  lapply(1:nb_sim, function(sim_id){
    # (1) Generate a single dataset
    sim_data <- CyTOF:::function_apply_onesimulation_withmarkerinfo(ls_variation)
    # (2) Apply methods
    res_mod <- CyTOF:::function_apply_modelcomputations_modelchoice(
      list_combined_output = sim_data,
      model = modelcheckGroup)
    # (3) Discard data for memory space
    rm(sim_data)
    # Return
    return(list("res_models" = res_mod))
    # (4) Repeat
  })
}

# Each parameter for one set of parameters was defined:
# Number of simulations
nb_sim
# Number of donors
nb_donors
# Number of markers
nb_markers
## Parameters of markers
name_marker <- paste0("m_", 1:nb_markers)
## Log Change
vect_logchange
logchange <- c(vect_logchange, rep(1, nb_markers-length(vect_logchange)))
## Subject effect
value_subeff
subeff <- rep(value_subeff, nb_markers)
## Mean
mean_negbino
## Dispersion
disp_negbino
# Models to test
modelcheck
# Number of cells per sample
nb_cells
# Create a data.frame containing these parameters
df_var <- data.frame(marker_name = name_marker,
                     mu0 = rep(mean_negbino, nb_markers),
                     dispersion = rep(disp_negbino, nb_markers),
                     subject_effect = subeff,
                     nb_donor = rep(nb_donors, nb_markers),
                     nb_cell_per_sample = rep(nb_cells, nb_markers),
                     rho = logchange)
# Convert the parameters data.frame as a list
ls_var <- split(df_var, df_var$marker_name)

# The workflow was applied
# Workflow
ls_res <- fct_workflow(nb_sim = nb_sim,
                       ls_variation = ls_var,
                       modelcheckGroup = modelcheck)

# Results for the different simulations were combined
# Models
df_res_models <- do.call("bind_rows", list(lapply(ls_res, function(x){
  x[["res_models"]]
}), .id = "i"))
# Power was computed for alpha = 0.05
pwr_values <- CyTOFpower:::compute_pwr(df_res_models)
colnames(pwr_values)[2] <- "marker_name"
pwr_values <- left_join(pwr_values,
                        df_var)

#' Run DS tests for one simulation.
#'
#' @details Wrapper to run the models through the different simulations.
#'
#' @param list_combined_output list, of simulated data (output of the
#' function_apply_onesimulation_withmarkerinfo function).
#' @param model vector, name(s) of models to test.
#'
#' @return data.frame of results for each simulation.
#'
#' @keywords internal
function_apply_modelcomputations_modelchoice <- function(list_combined_output,
                                                          model = c("cytoglmm",
                                                                    "cytoglm",
                                                                    "testDS_limma_random",
                                                                    "testDS_limma_fixed",
                                                                    "testDS_lmm")) {

  print(list_combined_output$variation)
  # Repeat model computation
  res_output <-
    function_to_compute_model_computation_onesimulation_modelchoice(onevariation = list_combined_output,
                                                                    model = model)
  row.names(res_output) <- seq_len(dim(res_output)[1])
  # Return
  return(res_output)
}

#' Run DS tests for one simulation.
#'
#' @details Function to run the DS tests through the different models.
#'
#' @param onevariation list, of simulated data (output of the
#'   function_wrapper_apply_simulation_nbtimes function).
#' @param model vector, name(s) of models to test.
#'
#' @return data.frame of results for each simulation all models combined.
#'
#' @keywords internal
function_to_compute_model_computation_onesimulation_modelchoice <- function(onevariation,
                                                                            model){
  # Split info from the mock datasets
  onemockdataset <- onevariation$ls_mock_data

  # Names DE markers
  vec_names_DEmarkers <- onevariation$DE_markers_names
  names_DEmarkers <- paste(vec_names_DEmarkers, collapse = ";")

  # Initialize results list
  ls_res <- list()

  # cytoGLMM
  if (any(model %in% "cytoglmm")) {
    # CytoGLMM - GLMM
    ls_glmm <- function_run_cytoGLMM(onemockdataset)
    #### All p-values
    allres_glmm <- function_summary_results_models(ls_glmm, package = "CytoGLMM")
    ls_res[["cytoglmm"]] <- allres_glmm
  }
  if (any(model %in% "cytoglm")) {
    # CytoGLMM - Bootstrap
    ls_bootstrap_glm <- function_run_bootstrapcytoGLMM(onemockdataset, nb_bootstrap = 50)
    allres_glm <- function_summary_results_models(ls_bootstrap_glm, package = "CytoGLMM")
    ls_res[["cytoglm"]] <- allres_glm
  }

  # Diffcyt
  ## Run models
  if (any(model %in% "testDS_limma_random")) {
    ### limma random
    ls_diffcyt_limma_random <- function_run_diffcyt_full_pipeline(onevariation = onevariation,
                                                                  model = "limma",
                                                                  effect = "random")
    #### All p-values
    allres_diffcyt_limma_random <- function_summary_results_models(ls_diffcyt_limma_random, package = "diffcyt")
    ls_res[["testDS_limma_random"]] <- allres_diffcyt_limma_random
  }

  if (any(model %in% "testDS_limma_fixed")) {
    ### limma fixed
    ls_diffcyt_limma_fixed <- function_run_diffcyt_full_pipeline(onevariation = onevariation,
                                                                 model = "limma",
                                                                 effect = "fixed")
    #### All p-values
    allres_diffcyt_limma_fixed <- function_summary_results_models(ls_diffcyt_limma_fixed, package = "diffcyt")
    ls_res[["testDS_limma_fixed"]] <- allres_diffcyt_limma_fixed
  }

  if (any(model %in% "testDS_lmm") ) {
    ### LMM
    ls_diffcyt_LMM_random <- function_run_diffcyt_full_pipeline(onevariation = onevariation,
                                                                model = "LMM",
                                                                effect = "random")
    #### All p-values
    allres_diffcyt_LMM_random <- function_summary_results_models(ls_diffcyt_LMM_random, package = "diffcyt")
    ls_res[["testDS_lmm"]] <- allres_diffcyt_LMM_random
  }

  # Combine p-val tables
  allpval_res <- dplyr::bind_rows(ls_res, .id = "model")
  # Add the information about the truth, i.e. which markers have DE by design
  allpval_res <- dplyr::mutate(allpval_res,
                               truth = ifelse(marker_id %in% as.character(vec_names_DEmarkers), 1, 0))

  # Return
  return(allpval_res)
}

# Test functions that run models for one simulation

# Create list of parameters combination for 3 markers
variation <- list(data.frame("marker_name" = "m1",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3),
                  data.frame("marker_name" = "m2",
                             "nb_donor" = 3,
                             "rho" = 1.1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3),
                  data.frame("marker_name" = "m3",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3))
# Create a mock dataset
df_exp_info <- data.frame("group_id" = as.factor(rep(c("A", "B"), times = 3)),
                          "donor_id" = rep(c("donor_1", "donor_2", "donor_3"), each = 2),
                          "sample_id" = paste0("sample_", c(1,4,2,5,3,6)))
df_exp_info_rep <- df_exp_info[rep(seq_len(nrow(df_exp_info)), each = 3), ]
df_raw_data <- data.frame(df_exp_info,
                          "m1" = c(14, 4, 9, 17, 10, 9, 4, 2, 5, 2, 14, 1, 11, 4, 10, 9, 22, 16),
                          "m2" = c(10, 5, 16, 12, 12, 13, 10, 3, 11, 6, 5, 6, 6, 5, 16, 8, 17, 8),
                          "m3" = c(8, 5, 6, 3, 6, 10, 7, 2, 12, 7, 4, 14, 12, 24, 5, 12, 20, 20))
trans_data <- asinh(df_raw_data[, c("m1", "m2", "m3")]/5)
df_trans_data <- data.frame(df_exp_info,
                            trans_data)
ls_3markers <- list("variation" = bind_rows(variation),
                    "df_info" = tibble::as_tibble(df_exp_info),
                    "DE_markers_names" = "m2",
                    "ls_mock_data" = tibble::as_tibble(df_trans_data),
                    "ls_mock_raw_data" = tibble::as_tibble(df_raw_data))

# Test function_to_compute_model_computation_onesimulation_modelchoice() ---------------------------------------------------------------------------

# Test
test_that("Run models", {
  # Set seed
  set.seed(123)
  # Run model - cytoglmm
  res_cytoglmm <- function_to_compute_model_computation_onesimulation_modelchoice(
    onevariation = ls_3markers,
    model = "cytoglmm")

  # Test output
  # Is it a list?
  expect_type(res_cytoglmm, "list")
  # Does it have the right structure?
  expect_identical(names(res_cytoglmm),
                   c("model", "marker_id", "p_val", "p_adj", "truth"))

  # Run model - testDS_limma_random
  res_limma_random <- function_to_compute_model_computation_onesimulation_modelchoice(
    onevariation = ls_3markers,
    model = "testDS_limma_random")
  # Test output
  # Is it a list?
  expect_type(res_limma_random, "list")
  # Does it have the right structure?
  expect_identical(names(res_limma_random),
                   c("model", "marker_id", "p_val", "p_adj", "truth"))

  # Run model - testDS_limma_fixed
  res_limma_fixed <- function_to_compute_model_computation_onesimulation_modelchoice(
    onevariation = ls_3markers,
    model = "testDS_limma_fixed")
  # Test output
  # Is it a list?
  expect_type(res_limma_fixed, "list")
  # Does it have the right structure?
  expect_identical(names(res_limma_fixed),
                   c("model", "marker_id", "p_val", "p_adj", "truth"))

  # Run model - testDS_lmm
  res_lmm <- function_to_compute_model_computation_onesimulation_modelchoice(
    onevariation = ls_3markers,
    model = "testDS_lmm")
  # Test output
  # Is it a list?
  expect_type(res_lmm, "list")
  # Does it have the right structure?
  expect_identical(names(res_lmm),
                   c("model", "marker_id", "p_val", "p_adj", "truth"))
})

# Test function_apply_modelcomputations_modelchoice() ---------------------------------------------------------------------------

# Test
test_that("Wrapper to run models", {
  # Same output as in function_to_compute_model_computation_onesimulation_modelchoice()
  # as it is a wrapper around this latest function
  # Set seed
  set.seed(123)
  # Run model - cytoglmm
  res_cytoglmm <- function_apply_modelcomputations_modelchoice(list_combined_output = ls_3markers,
                                                               model = "cytoglmm")

  # Test output
  # Is it a list?
  expect_type(res_cytoglmm, "list")
  # Does it have the right structure?
  expect_identical(names(res_cytoglmm),
                   c("model", "marker_id", "p_val", "p_adj", "truth"))

  # Run model - testDS_limma_random
  res_limma_random <- function_apply_modelcomputations_modelchoice(list_combined_output = ls_3markers,
                                                                   model = "testDS_limma_random")
  # Test output
  # Is it a list?
  expect_type(res_limma_random, "list")
  # Does it have the right structure?
  expect_identical(names(res_limma_random),
                   c("model", "marker_id", "p_val", "p_adj", "truth"))

  # Run model - testDS_limma_fixed
  res_limma_fixed <- function_apply_modelcomputations_modelchoice(list_combined_output = ls_3markers,
                                                                  model = "testDS_limma_fixed")
  # Test output
  # Is it a list?
  expect_type(res_limma_fixed, "list")
  # Does it have the right structure?
  expect_identical(names(res_limma_fixed),
                   c("model", "marker_id", "p_val", "p_adj", "truth"))

  # Run model - testDS_lmm
  res_lmm <- function_apply_modelcomputations_modelchoice(list_combined_output = ls_3markers,
                                                          model = "testDS_lmm")
  # Test output
  # Is it a list?
  expect_type(res_lmm, "list")
  # Does it have the right structure?
  expect_identical(names(res_lmm),
                   c("model", "marker_id", "p_val", "p_adj", "truth"))
})

### Function to run models from the CytoGLMM package ###

#' Run cytoglmm
#'
#' @details Function to run GLMM model from CytoGLMM package.
#' @param mock_dataset data.frame, cell values for each marker.
#'
#' @return list of 3 slots:
#'     - model_fit: fit of the model;
#'     - plot: plot of the effects;
#'     - results_summary: data.frame containing the results of the models for
#'     each marker.
#'
#' @keywords internal
function_run_cytoGLMM <- function(mock_dataset){
  # Get marker names
  markers_names <- function_extract_marker_names(mock_dataset)
  #Run GLMM - suppress mbest warning
  glmm_fit <- suppressWarnings(CytoGLMM::cytoglmm(mock_dataset,
                                 protein_names = markers_names,
                                 condition = "group_id", group = "donor_id"))
  # Plot the effects
  plot_effects <- plot(glmm_fit)
  # Summary
  res_glmm_fit <- summary(glmm_fit)
  # List of results
  ls_res <- list("model_fit" = glmm_fit,
                 "plot" = plot_effects,
                 "result_summary" = res_glmm_fit)

  return(ls_res)
}

#' Run cytoglm.
#'
#' @details Function to run the Generalized Linear Model with Bootstrap,
#' from the CytoGLMM package.
#' @param mock_dataset data.frame, cell values for each marker.
#' @param nb_bootstrap numeric, number of bootstrap (by defaults nb_bootstrap = 1000).
#'
#' @return list of 3 slots:
#'     - model_fit: fit of the model;
#'     - plot: plot of the effects;
#'     - results_summary: data.frame containing the results of the models for
#'     each marker.
#'
#' @keywords internal
function_run_bootstrapcytoGLMM <- function(mock_dataset, nb_bootstrap = 500){
  # Get marker names
  markers_names <- function_extract_marker_names(mock_dataset)
  # Run GLM
  glm_fit_bootstrap <- CytoGLMM::cytoglm(mock_dataset,
                                         num_boot = nb_bootstrap,
                                         protein_names = markers_names,
                                         condition = "group_id",
                                         group = "donor_id")
  # Plot the effects
  plot_effects_bootstrap <- plot(glm_fit_bootstrap)
  # Summary
  res_glm_fit_bootstrap <- summary(glm_fit_bootstrap)

  # List of results
  ls_res <- list("model_fit" = glm_fit_bootstrap,
                 "plot" = plot_effects_bootstrap,
                 "result_summary" = res_glm_fit_bootstrap)

  return(ls_res)
}

### Functions to run the models from the diffcyt package ###

#' Compute cells counts and medians.
#'
#' @details Function to calculate features for diffcyt package models.
#'
#' @param mock_flowset data.frame, cell values for each marker.
#'
#' @return list with cell counts and medians for each markers.
#'
#' @keywords internal
function_compute_diffcyt_features <- function(mock_flowset){
  # Calculate features
  # Cluster cell counts
  d_mock_flowset_counts <- diffcyt::calcCounts(mock_flowset)
  # Cluster medians
  d_mock_flowset_medians <- diffcyt::calcMedians(mock_flowset)
  # Return
  return(list("counts" = d_mock_flowset_counts,
              "medians" = d_mock_flowset_medians))
}

#' Design and contrast matrices for diffcyt-DS-limma with random effect.
#'
#' @details Function to create the design matrix and contrast for the
#' diffcyt-DS-limma model with random effect from the diffcyt package.
#'
#' @param df_experiment_info data.frame, information about the experiment (donor IDs,
#' group IDs and sample IDs).
#'
#' @return list with 3 slots:
#'     - design_matrix: the design matrix;
#'     - contrast: the contrast matrix;
#'     - effect: the specification of the "random" effect.
#'
#' @keywords internal
function_desigmat_contrast_diffcytDSlimma_randomeffect <- function(df_experiment_info){
  # Create design matrix
  designmatrix <- diffcyt::createDesignMatrix(df_experiment_info,
                                              cols_design = c("group_id"))
  # Create contrast
  contrast <- diffcyt::createContrast(c(0, 1))
  # Assign a variable for the effect
  effect <- "random"
  # Return
  return(list("design_matrix" = designmatrix,
              "contrast" = contrast,
              "effect" = effect))
}

#' Design and contrast matrices for diffcyt-DS-limma with fixed effect.
#'
#' @details Function to create the design matrix and contrast for the diffcyt-DS-limma model
#'with fixed effect.
#' @param df_experiment_info data.frame, information about the experiment (donor IDs,
#' group IDs and sample IDs).
#'
#' @return list with 3 slots:
#'     - design_matrix: the design matrix;
#'     - contrast: the contrast matrix;
#'     - effect: the specification of the "fixed" effect.
#' @keywords internal
function_desigmat_contrast_diffcytDSlimma_fixedeffect <- function(df_experiment_info){
  # Create design matrix
  designmatrix <- diffcyt::createDesignMatrix(df_experiment_info,
                                              cols_design = c("group_id", "donor_id"))
  # Create contrast
  contrast <- diffcyt::createContrast(c(0, 1, rep(0, dim(designmatrix)[2]-2)))
  # Assign a variable for the effect
  effect <- "fixed"
  # Return
  return(list("design_matrix" = designmatrix,
              "contrast" = contrast,
              "effect" = effect))
}

#' Run diffcyt-DS-limma model.
#'
#' @details Function to run diffcyt-DS-limma model from the diffcyt package.
#'
#' @param ls_desigmat_contrast list, with design and contrast matrices.
#' @param df_experiment_info data.frame, information about the experiment (donor IDs,
#' group IDs and sample IDs).
#' @param ls_features list, with cell counts and medians for each markers.
#'
#' @return list with 2 slots:
#'     - model_fit: the model fit;
#'     - result_summary: results of the model for each marker.
#'
#' @keywords internal
function_run_diffcytDSlimma <- function(ls_desigmat_contrast,
                                        df_experiment_info,
                                        ls_features){
  # Run the model depending on the effects (random or fixed)
  if(ls_desigmat_contrast$effect == "random"){
    #message("Running diffcyt-DS-limma model with random effect")
    res_mock_flowset <- diffcyt::testDS_limma(
      d_counts = ls_features$counts,
      d_medians = ls_features$medians,
      design = ls_desigmat_contrast$design_matrix,
      contrast = ls_desigmat_contrast$contrast,
      block_id = df_experiment_info$donor_id)
  } else if(ls_desigmat_contrast$effect == "fixed"){
    #message("Running diffcyt-DS-limma model with fixed effect")
    res_mock_flowset <- diffcyt::testDS_limma(
      d_counts = ls_features$counts,
      d_medians = ls_features$medians,
      design = ls_desigmat_contrast$design_matrix,
      contrast = ls_desigmat_contrast$contrast)
  }
  # Results
  table_res_mock_flowset <- SummarizedExperiment::rowData(res_mock_flowset, format_vals = TRUE)
  # Return
  ls_res <- list("model_fit" = res_mock_flowset, "result_summary" = table_res_mock_flowset)
  return(ls_res)
}

#' Formula and contrast matrix for diffcyt-DS-LMM with random effect.
#'
#' @details Function to create formula and contrast for diffcyt-DS-LMM with random effect.
#'
#' @param df_experiment_info data.frame, information about the experiment (donor IDs,
#' group IDs and sample IDs).
#'
#' @return list with 3 slots:
#'     - formula: the formula for the model;
#'     - contrast: the contrast matrix.
#'
#' @keywords internal
function_formula_contrast_diffcytDSLMM_randomeffect <- function(df_experiment_info){
  # Create formula
  formula_withrandomeffect <-
    diffcyt::createFormula(df_experiment_info,
                           cols_fixed = c("group_id"),
                           cols_random = c("donor_id"))
  # Create contrast
  contrast_withrandomeffect <- diffcyt::createContrast(c(0, 1)) # no 0 for the random effect
  # Return
  return(list("formula" = formula_withrandomeffect,
              "contrast" = contrast_withrandomeffect))
}

#' Run diffcyt-DS-LMM model.
#'
#' @details Function to run diffcyt-DS-LMM model from the diffcyt package.
#'
#' @param ls_form_contrast list, with formula and constrat matrix.
#' @param df_experiment_info data.frame, information about the experiment (donor IDs,
#' group IDs and sample IDs).
#' @param ls_features list, with cell counts and medians for each markers.
#'
#' @return list with 2 slots:
#'     - model_fit: the model fit;
#'     - result_summary: results of the model for each marker.
#'
#' @keywords internal
function_run_diffcytDSLMM <- function(ls_form_contrast, df_experiment_info, ls_features){
  # DS test within clusters with LMM
  res_mock_flowset <- diffcyt::testDS_LMM(
    d_counts = ls_features$counts,
    d_medians = ls_features$medians,
    formula = ls_form_contrast$formula,
    contrast = ls_form_contrast$contrast)
  # Results
  table_res_mock_flowset <- SummarizedExperiment::rowData(res_mock_flowset,
                                                          format_vals = TRUE)
  # Return
  ls_res <- list("model_fit" = res_mock_flowset,
                 "result_summary" = table_res_mock_flowset)
  return(ls_res)
}

#' Run diffcyt pipeline
#'
#' @details Function to run diffcyt pipeline. We do not used the diffcyt function
#' directly because of the limma model run differently with the effects.
#'
#' @param onevariation list, of simulated data (output of the
#'   function_wrapper_apply_simulation_nbtimes function).
#' @param model character, model to run: "limma" or "LMM".
#' @param effect character, effect: "random" or "fixed".
#'
#' @return list with 2 slots:
#'     - model_fit: the model fit;
#'     - result_summary: results of the model for each marker.
#'
#' @keywords internal
function_run_diffcyt_full_pipeline <- function(onevariation,
                                               model = c("limma", "LMM"),
                                               effect = c("random", "fixed")){
  # Prepare data
  # Mock dataset
  mock_dataset <- onevariation$ls_mock_data
  # Experimental info
  df_experiment_info <- onevariation$df_info
  # Marker names
  markers_names <- function_extract_marker_names(mock_dataset)
  # Create metadata
  # colData
  mock_flowset_markerinfo <- data.frame("channel_name" = markers_names,
                                        "marker_name" = markers_names,
                                        "marker_class" = "state")
  # rowData
  se_df_info <- data.frame(mock_dataset[,c("group_id", "donor_id", "sample_id")],
                           "cluster_id" = "pop1",
                           stringsAsFactors = TRUE)
  # Number of cells per sample
  se_n_cells <- rep(unique(onevariation$variation$nb_cell_per_sample),
                    each = length(onevariation$df_info$sample_id))
  names(se_n_cells) <- paste0("Sample",
                              seq_len(length(onevariation$df_info$sample_id)))
  # metadata
  met <- list("experiment_info" = data.frame(onevariation$df_info,
                                             "cluster_id" = "pop1"),
              "n_cells" = se_n_cells)
  # Create SummarizedExperiment
  d_flowset <- SummarizedExperiment::SummarizedExperiment(
    assays = list("exprs" = as.matrix(mock_dataset[, markers_names])),
    rowData = se_df_info,
    colData = mock_flowset_markerinfo,
    metadata = met)
  # Compute features
  ls_features <- function_compute_diffcyt_features(d_flowset)
  # Create design matrix or formula and constrast depending on choosen model
  if(model == "LMM"){
    message("Run the LMM model with random effect")
    # Create formula and contrast
    ls_form <- function_formula_contrast_diffcytDSLMM_randomeffect(df_experiment_info)
    # Run the model
    res <- function_run_diffcytDSLMM(ls_form, df_experiment_info, ls_features)
  } else if(model == "limma" & effect == "random"){
    message("Run the limma model with random effect")
    # Create design matrix and contrast
    ls_desig <- function_desigmat_contrast_diffcytDSlimma_randomeffect(df_experiment_info)
    # Run the model
    res <- function_run_diffcytDSlimma(ls_desig, df_experiment_info, ls_features)
  } else if(model == "limma" & effect == "fixed"){
    message("Run the limma model with fixed effect")
    # Create design matrix and contrast
    ls_desig <- function_desigmat_contrast_diffcytDSlimma_fixedeffect(df_experiment_info)
    # Run the model
    res <- function_run_diffcytDSlimma(ls_desig, df_experiment_info, ls_features)
  } else {
    stop("Model not correctly specified")
  }
  # Return
  return(res)
}

# Test function to run the models

# Create list of parameters combination for 3 markers
variation <- list(data.frame("marker_name" = "m1",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3),
                  data.frame("marker_name" = "m2",
                             "nb_donor" = 3,
                             "rho" = 1.1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3),
                  data.frame("marker_name" = "m3",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3))
# Create a mock dataset
df_exp_info <- data.frame("group_id" = as.factor(rep(c("A", "B"), times = 3)),
                          "donor_id" = rep(c("donor_1", "donor_2", "donor_3"), each = 2),
                          "sample_id" = paste0("sample_", c(1,4,2,5,3,6)))
df_exp_info_rep <- df_exp_info[rep(seq_len(nrow(df_exp_info)), each = 3), ]
df_raw_data <- data.frame(df_exp_info,
                          "m1" = c(14, 4, 9, 17, 10, 9, 4, 2, 5, 2, 14, 1, 11, 4, 10, 9, 22, 16),
                          "m2" = c(10, 5, 16, 12, 12, 13, 10, 3, 11, 6, 5, 6, 6, 5, 16, 8, 17, 8),
                          "m3" = c(8, 5, 6, 3, 6, 10, 7, 2, 12, 7, 4, 14, 12, 24, 5, 12, 20, 20))
trans_data <- asinh(df_raw_data[, c("m1", "m2", "m3")]/5)
df_trans_data <- data.frame(df_exp_info,
                            trans_data)
ls_3markers <- list("variation" = bind_rows(variation),
                    "df_info" = tibble::as_tibble(df_exp_info),
                    "DE_markers_names" = "m2",
                    "ls_mock_data" = tibble::as_tibble(df_trans_data),
                    "ls_mock_raw_data" = tibble::as_tibble(df_raw_data))

# Create a summarized experiment with the mock dataset
# Marker names
markers_names <- function_extract_marker_names(ls_3markers$ls_mock_data)
# Create metadata
# colData
mock_flowset_markerinfo <- data.frame("channel_name" = markers_names,
                                      "marker_name" = markers_names,
                                      "marker_class" = "state")
# rowData
se_df_info <- data.frame(ls_3markers$ls_mock_data[,c("group_id", "donor_id", "sample_id")],
                         "cluster_id" = "pop1",
                         stringsAsFactors = TRUE)
# Number of cells per sample
se_n_cells <- rep(unique(ls_3markers$variation$nb_cell_per_sample),
                  each = length(ls_3markers$df_info$sample_id))
names(se_n_cells) <- paste0("Sample",
                            seq_len(length(ls_3markers$df_info$sample_id)))
# metadata
met <- list("experiment_info" = data.frame(ls_3markers$df_info,
                                           "cluster_id" = "pop1"),
            "n_cells" = se_n_cells)
# Create SummarizedExperiment
d_sumexp <- SummarizedExperiment::SummarizedExperiment(
  assays = list("exprs" = as.matrix(ls_3markers$ls_mock_data[, markers_names])),
  rowData = se_df_info,
  colData = mock_flowset_markerinfo,
  metadata = met)


# test function_run_cytoGLMM() ---------------------------------------------------------------------------

# Expected p-values data.frame
df_res_sum <- tibble::tibble(
  "protein_name" = c("m2", "m3", "m1"),
  "pvalues_unadj" = c("m2" = 0.4, "m3" = 0.7, "m1" = 0.8),
  "pvalues_adj" = c("m2" = 0.8, "m3" = 0.8, "m1" = 0.8))

# Test
test_that("Run the CytoGLMM - GLMM model", {
  # Set seed
  set.seed(123)
  # Run model
  cytoglmm_res <- function_run_cytoGLMM(
      mock_dataset = ls_3markers$ls_mock_data)
  # Test output
  # Is it a list?
  expect_type(cytoglmm_res, "list")
  # Does it have the right structure?
  expect_identical(names(cytoglmm_res),
                   c("model_fit", "plot", "result_summary"))
  # Are the p-values correct?
  expect_equal(cytoglmm_res$result_summary,
               df_res_sum,
               tolerance = 1e-1)
})

# test function_compute_diffcyt_features() ---------------------------------------------------------------------------

# Expected counts in the assays
v_exp_counts <- matrix(rep(3, 6),
                       nrow = 1,
                       dimnames = list(c("pop1"),
                                       c("sample_1",
                                         "sample_4",
                                         "sample_2",
                                         "sample_5",
                                         "sample_3",
                                         "sample_6")))
# Expected medians in the assays
v_exp_medians <- matrix(c(1.5, 0.7, 1.3, 1.3, 1.7, 1.3),
                        nrow = 1,
                        dimnames = list(c("pop1"),
                                        c("sample_1",
                                          "sample_4",
                                          "sample_2",
                                          "sample_5",
                                          "sample_3",
                                          "sample_6")))


# Test
test_that("Compute the diffcyt features", {
  # Set seed
  set.seed(123)
  # Compute the features
  ls_features <- function_compute_diffcyt_features(d_sumexp)
  # Test output
  # Is it a list?
  expect_type(ls_features, "list")
  # Does it have the right structure?
  expect_identical(names(ls_features),
                   c("counts", "medians"))
  # Are the values correct?
  # Counts
  expect_equal(SummarizedExperiment::assay(ls_features$counts),
               v_exp_counts)
  # Median
  expect_equal(SummarizedExperiment::assay(ls_features$medians),
               v_exp_medians,
               tolerance = 1e-1)
})

# test function_desigmat_contrast_diffcytDSlimma_randomeffect() ---------------------------------------------------------------------------

# Expected design matrix
mat_design_mat_randomeffect <- matrix(c(rep(1, 6), rep(c(0, 1), times = 3)),
                                      ncol = 2,
                                      dimnames = list(1:6,
                                                      c("(Intercept)", "group_idB")))

# Test
test_that("Contrast for limma model with random effect", {
  # Set seed
  set.seed(123)
  # Generate the contrast
  ls_contrast <- function_desigmat_contrast_diffcytDSlimma_randomeffect(df_exp_info)
  # Test output
  # Is it a list?
  expect_type(ls_contrast, "list")
  # Does it have the right structure?
  expect_identical(names(ls_contrast),
                   c("design_matrix", "contrast", "effect"))
  # Are the values of the matrix equal to the expected values?
  expect_equal(ls_contrast$design_matrix[,"(Intercept)"],
               mat_design_mat_randomeffect[,"(Intercept)"])
  expect_equal(ls_contrast$design_matrix[,"group_idB"],
               mat_design_mat_randomeffect[,"group_idB"])
  expect_identical(ls_contrast$contrast,
                   matrix(c(0, 1), ncol = 1))
  expect_identical(ls_contrast$effect,
                   "random")
})

# test function_desigmat_contrast_diffcytDSlimma_fixedeffect() ---------------------------------------------------------------------------

# Expected design matrix
mat_design_mat_donorids <-
  matrix(c(0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1),
         ncol = 2,
         dimnames = list(1:6,
                         c("donor_iddonor_2", "donor_iddonor_3")))
mat_design_mat_fixedeffect <- cbind(mat_design_mat_randomeffect,
                                    mat_design_mat_donorids)

# Test
test_that("Contrast for limma model with fixed effect", {
  # Set seed
  set.seed(123)
  # Generate the contrast
  ls_contrast <- function_desigmat_contrast_diffcytDSlimma_fixedeffect(df_exp_info)
  # Test output
  # Is it a list?
  expect_type(ls_contrast, "list")
  # Does it have the right structure?
  expect_identical(names(ls_contrast),
                   c("design_matrix", "contrast", "effect"))
  # Are the values of the matrix equal to the expected values?
  expect_equal(ls_contrast$design_matrix[,"(Intercept)"],
               mat_design_mat_fixedeffect[,"(Intercept)"])
  expect_equal(ls_contrast$design_matrix[,"group_idB"],
               mat_design_mat_fixedeffect[,"group_idB"])
  expect_equal(ls_contrast$design_matrix[,"donor_iddonor_2"],
               mat_design_mat_fixedeffect[,"donor_iddonor_2"])
  expect_equal(ls_contrast$design_matrix[,"donor_iddonor_3"],
               mat_design_mat_fixedeffect[,"donor_iddonor_3"])
  expect_identical(ls_contrast$contrast,
                   matrix(c(0, 1, 0, 0), ncol = 1))
  expect_identical(ls_contrast$effect,
                   "fixed")
})

# test function_run_diffcytDSlimma() ---------------------------------------------------------------------------

# Test
test_that("Run diffcyt-DS-limma model", {
  # Set seed
  set.seed(123)
  # Run the model
  # Compute the features
  ls_features <- function_compute_diffcyt_features(d_sumexp)

  # With fixed effect
  # Compute the contrast
  ls_desigmat_contrast_f <- function_desigmat_contrast_diffcytDSlimma_fixedeffect(df_exp_info)
  # Run model
  ls_res_model_f <- function_run_diffcytDSlimma(ls_desigmat_contrast_f,
                                                df_experiment_info,
                                                ls_features)
  # Test the output
  # Is it a list?
  expect_type(ls_res_model_f, "list")
  # Does it have the right structure?
  expect_identical(names(ls_res_model_f),
                   c("model_fit", "result_summary"))
  # Are the p-values equal to the expected ones?
  expect_equal(ls_res_model_f$result_summary$p_adj,
               c(0.1, 0.05, 0.7),
               tolerance = 1e-1)

  # With random effect
  # Compute the contrast
  ls_desigmat_contrast_r <- function_desigmat_contrast_diffcytDSlimma_fixedeffect(df_exp_info)
  # Run the model
  ls_res_model_r <- function_run_diffcytDSlimma(ls_desigmat_contrast_r,
                                                df_experiment_info,
                                                ls_features)
  # Test the output
  # Is it a list?
  expect_type(ls_res_model_r, "list")
  # Does it have the right structure?
  expect_identical(names(ls_res_model_r),
                   c("model_fit", "result_summary"))
  # Are the p-values equal to the expected ones?
  expect_equal(ls_res_model_r$result_summary$p_adj,
               c(0.1, 0.05, 0.7),
               tolerance = 1e-1)
})

# test function_formula_contrast_diffcytDSLMM_randomeffect() ---------------------------------------------------------------------------

# Test
test_that("Contrast for LMM model", {
  # Set seed
  set.seed(123)
  # Generate formula and contrast
  ls_contrast_LMM <- function_formula_contrast_diffcytDSLMM_randomeffect(df_exp_info)
  # Test output
  # Is it a list?
  expect_type(ls_contrast_LMM, "list")
  # Does it have the right structure?
  expect_identical(names(ls_contrast_LMM),
                   c("formula", "contrast"))
  # Check the formula
  expect_equal(ls_contrast_LMM$formula$formula,
               formula("y ~ group_id + (1 | donor_id)"),
               ignore_formula_env	= TRUE)
  # Is the random_terms equal TRUE?
  expect_true(ls_contrast_LMM$formula$random_terms)
  # Are the data equal to the experimental information?
  expect_identical(ls_contrast_LMM$formula$data,
                   df_exp_info[, c("group_id", "donor_id")])
  # Check contrast
  expect_identical(ls_contrast_LMM$contrast,
                   matrix(c(0, 1), ncol = 1))
})

# test function_run_diffcytDSLMM() ---------------------------------------------------------------------------

# Test
test_that("Run diffcyt-DS-LMM model", {
  # Set seed
  set.seed(123)
  # Generate formula/contrast
  ls_contrast_LMM <- function_formula_contrast_diffcytDSLMM_randomeffect(
    df_experiment_info = df_exp_info)
  # Compute the features
  ls_features <- function_compute_diffcyt_features(d_sumexp)
  # Run the model
  ls_res_model_lmm <- function_run_diffcytDSLMM(ls_form_contrast = ls_contrast_LMM,
                                                df_experiment_info = df_exp_info,
                                                ls_features = ls_features)

  # Test the output
  # Is it a list?
  expect_type(ls_res_model_lmm, "list")
  # Does it have the right structure?
  expect_identical(names(ls_res_model_lmm),
                   c("model_fit", "result_summary"))
  # Are the p-values equal to the expected ones?
  expect_equal(ls_res_model_lmm$result_summary$p_adj,
               c(0.1, 0.0, 0.5),
               tolerance = 1e-0)
})

# test function_run_diffcyt_full_pipeline() ---------------------------------------------------------------------------

# Test
test_that("Run the full diffcyt pipeline", {
  # Set seed
  set.seed(123)
  # In this test we check that the switch between the different models is
  # done correctly

  # diffcyt-DS-limma random
  # Check message
  expect_message(function_run_diffcyt_full_pipeline(onevariation = ls_3markers,
                                                    model = c("limma"),
                                                    effect = c("random")),
                 regexp = "Run the limma model with random effect")
  # diffcyt-DS-limma fixed
  # Check message
  expect_message(function_run_diffcyt_full_pipeline(onevariation = ls_3markers,
                                                    model = c("limma"),
                                                    effect = c("fixed")),
                 regexp = "Run the limma model with fixed effect")
  # diffcyt-DS-LMM
  # Check message
  expect_message(function_run_diffcyt_full_pipeline(onevariation = ls_3markers,
                                                    model = c("LMM")),
                 regexp = "Run the LMM model with random effect")
})

# Create list of parameters combination for 3 markers
variation <- list(data.frame("marker_name" = "m1",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3),
                  data.frame("marker_name" = "m2",
                             "nb_donor" = 3,
                             "rho" = 1.1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3),
                  data.frame("marker_name" = "m3",
                             "nb_donor" = 3,
                             "rho" = 1,
                             "subject_effect" = 0.1,
                             "mu0" = 10,
                             "dispersion" = 3,
                             "nb_cell_per_sample" = 3))
# Create a mock dataset
df_exp_info <- data.frame("group_id" = as.factor(rep(c("A", "B"), times = 3)),
                          "donor_id" = rep(c("donor_1", "donor_2", "donor_3"), each = 2),
                          "sample_id" = paste0("sample_", c(1,4,2,5,3,6)))
df_exp_info_rep <- df_exp_info[rep(seq_len(nrow(df_exp_info)), each = 3), ]
df_raw_data <- data.frame(df_exp_info,
                          "m1" = c(14, 4, 9, 17, 10, 9, 4, 2, 5, 2, 14, 1, 11, 4, 10, 9, 22, 16),
                          "m2" = c(10, 5, 16, 12, 12, 13, 10, 3, 11, 6, 5, 6, 6, 5, 16, 8, 17, 8),
                          "m3" = c(8, 5, 6, 3, 6, 10, 7, 2, 12, 7, 4, 14, 12, 24, 5, 12, 20, 20))
trans_data <- asinh(df_raw_data[, c("m1", "m2", "m3")]/5)
df_trans_data <- data.frame(df_exp_info,
                            trans_data)
ls_3markers <- list("variation" = bind_rows(variation),
                    "df_info" = tibble::as_tibble(df_exp_info),
                    "DE_markers_names" = "m2",
                    "ls_mock_data" = tibble::as_tibble(df_trans_data),
                    "ls_mock_raw_data" = tibble::as_tibble(df_raw_data))

# Test function_summary_results_models() ---------------------------------------------------------------------------

# Test
test_that("Format of the output of the models", {
  # Set seed
  set.seed(123)
  # Run cytoglmm model
  # CytoGLMM - GLMM
  ls_glmm <- function_run_cytoGLMM(ls_3markers$ls_mock_data)
  # Summarize the results
  allres_glmm <- function_summary_results_models(ls_glmm, package = "CytoGLMM")
  # Test output
  # Is it a list?
  expect_type(allres_glmm, "list")
  # Does it have the right structure?
  expect_identical(names(allres_glmm),
                   c("marker_id", "p_val", "p_adj"))

  # Run diffcyt model
  # as example we use LMM
  ls_diffcyt_LMM_random <- function_run_diffcyt_full_pipeline(onevariation = ls_3markers,
                                                              model = "LMM",
                                                              effect = "random")
  # Summarize the results
  allres_diffcyt_LMM_random <- function_summary_results_models(ls_diffcyt_LMM_random, package = "diffcyt")
  # Test output
  # Is it a list?
  expect_type(allres_diffcyt_LMM_random, "list")
  # Does it have the right structure?
  expect_identical(names(allres_diffcyt_LMM_random),
                   c("marker_id", "p_val", "p_adj"))
})

---
title: "Power analysis for CyTOF experiments"
author: 
  name: "Anne-Maud Ferreira"
  affiliation: Department of Statistics, Stanford University
package: CyTOFpower
date: "`r Sys.Date()`"
output: BiocStyle::html_document
vignette: >
    %\VignetteIndexEntry{Power analysis for CyTOF experiments}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}  
bibliography: CyTOFpower.bib
---

```{r, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction

Mass Spectrometry (or CyTOF) is a single cell technology. It measures up to 
50 protein markers on a single cell. The markers are antibodies labeled with 
stable isotopes and they might be markers of cell types or phenotypes.

CyTOF might be used to determine if there is any differences in cell abundances 
(type markers) or cell phenotypes (state markers) between two experimental 
conditions. In this package, we are proposing a tool to predict the power of a 
differential state test analysis.

Two packages are available on Bioconductor to perform differential state test 
analyses: CytoGLMM [@seiler2020cytoglmm] and diffcyt [@weber2019diffcyt].
These models are available in this package and their results, the adjusted p-value
per marker, are used to compute the power an experiment.

# Simulate in-silico data

In-silico CyTOF data are simulated using the following data generation process. 
We assumed two conditions for which one condition is the baseline (i.e. a 
control condition where no marker is different from the other) and the other
condition contains some signals (i.e. at least one marker is differentially
expressed). The parameters are defined as follow:

- the number of donors: the design of the data is paired, so the number of 
samples will be calculated accordingly, i.e. twice the number of donors;
- the subject effect: it defines how much the donors are different from each 
others;
- the number of cells per samples;
- the total number of markers tested in the experiment;
- the fold change \rho of each differentially expressed marker: it represents 
how much different the marker is expected to be in comparison to the
control condition. The mean of these markers will be multiplied by \rho in 
the condition containing the differentially expressed markers;
- the distribution parameters for each marker: see details below.

The cell value's mean of each marker is drawn from a Gamma distribution: 
$$\mu_{0,ij} \sim \Gamma(k, θ)$$
where $i$ the donor, $j$ the marker, $k$ the shape and $\theta$ the scale. 
These two last parameters are defined using the parameters provided by the user: 

- cell value mean $\mu_{0}$ in the control condition: 
with $\mu_{0} = k  \cdot \theta > 0$;
- subject effect $S$: $S = \sqrt{k  \cdot \theta^{2}}$.

The cell value mean of the differentially expressed marker(s) is then multiplied 
by the fold change defined earlier: $\mu_{1,ij}= \mu_{0,ij} \cdot \rho_j$.


The cell values are drawn using a Negative Binomial:

- for non-differentially expressed markers: $X_{ij} \sim NB(\mu_{0,ij}, \sigma)$
- for differentially expressed markers: $X_{ij} \sim NB(\mu_{1,ij}, \sigma)$

Some of these parameters might need to be estimated using previous data or publicly
available datasets. For instance, the dispersion and mean parameters of the 
negative binomial distribution might be estimated using `fitdistr` from the 
`MASS` package for each marker.

# Power computation

The power is computed for the differentially expressed marker(s) (i.e. fold change
different from 1). It is based on the adjusted p-values reported by the models:
counting how many times the null hypothesis is correctly rejected.
It is also important to note that the power returned by these computations uses
the threshold of $\alpha = 0.05$ as a significance level.

# Shiny app

The shiny app is divided into two tabs: (1) the precomputed dataset tab: the
power was pre-computed for multiple combinations of parameters and the user is
able to search this grid of parameters; (2) the personalized dataset tab: the 
data and the power is computed on request based on the parameters chosen by
the user.

## Precomputed dataset 

This panel allows the user to search a grid of parameters that have been 
pre-computed. 
The value "NA" displays a power curve for the different values of this parameter.

The available parameters that the user can choose from are the following:

- The number of donors;
- The subject effect;
- The number of cells per sample;
- The total number of markers;
- The marker’s Fold Change (FC): 1.1, 1.2, 1.3, 1.5, 1.8, 2, 3;
- The mean of the Negative Binomial for the marker that is considered;
- The dispersion of the Negative Binomial for the marker that is considered;
- Models to run: CytoGLMM - GLMM; diffcyt - limma with fixed effect; 
diffcyt - limma with random effect; diffcyt - lme4.

## Personalized dataset

This panel allows the user to compute the power for a chosen set of parameters. 
The data are generated on request and it takes some time to get the results,
especially if the user would like to perform a high number of simulations
with a high number of cells.

The available parameters that the user can choose from are the following:

- The number of donors: at least 3 donors;
- The subject effect that must be different from 0;
- The number of cells per sample (minimum 10 cells);
- The total number of markers (minimum 3 markers);
- For each marker: the fold change, the mean and the dispersion have to be 
specified in the matrix;
- Model to run: CytoGLMM - GLMM; diffcyt - limma with fixed effect; 
diffcyt - limma with random effect; diffcyt - lme4;
- The number of simulations: we recommend at least 10 simulations.

## Run the app

The shiny app is run locally by calling the following function:

```{r run_app, eval = FALSE}
library(CyTOFpower)
CyTOFpower()
```

# Session information

```{r sessioninfo}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_names_DE_markers}
\alias{function_names_DE_markers}
\title{Generate name of the DE markers.}
\usage{
function_names_DE_markers(total_nb_marker, nb_DE_marker)
}
\arguments{
\item{total_nb_marker}{numeric, total number of markers.}

\item{nb_DE_marker}{numeric, number of DE markers.}
}
\value{
vactor of marker names.
}
\description{
Generate name of the DE markers.
}
\details{
Function to generate the name of the DE markers.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models.R
\name{function_formula_contrast_diffcytDSLMM_randomeffect}
\alias{function_formula_contrast_diffcytDSLMM_randomeffect}
\title{Formula and contrast matrix for diffcyt-DS-LMM with random effect.}
\usage{
function_formula_contrast_diffcytDSLMM_randomeffect(df_experiment_info)
}
\arguments{
\item{df_experiment_info}{data.frame, information about the experiment (donor IDs,
group IDs and sample IDs).}
}
\value{
list with 3 slots:
    - formula: the formula for the model;
    - contrast: the contrast matrix.
}
\description{
Formula and contrast matrix for diffcyt-DS-LMM with random effect.
}
\details{
Function to create formula and contrast for diffcyt-DS-LMM with random effect.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helperfunctions_for_app.R
\name{compute_pwr}
\alias{compute_pwr}
\title{Compute power}
\usage{
compute_pwr(model_values, alpha = 0.05)
}
\arguments{
\item{model_values}{data.frame, output of run_models().}

\item{alpha}{numeric, significance level.}
}
\value{
numeric, power.
}
\description{
Compute power
}
\details{
Compute the power based on the model values.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models.R
\name{function_run_diffcytDSLMM}
\alias{function_run_diffcytDSLMM}
\title{Run diffcyt-DS-LMM model.}
\usage{
function_run_diffcytDSLMM(ls_form_contrast, df_experiment_info, ls_features)
}
\arguments{
\item{ls_form_contrast}{list, with formula and constrat matrix.}

\item{df_experiment_info}{data.frame, information about the experiment (donor IDs,
group IDs and sample IDs).}

\item{ls_features}{list, with cell counts and medians for each markers.}
}
\value{
list with 2 slots:
    - model_fit: the model fit;
    - result_summary: results of the model for each marker.
}
\description{
Run diffcyt-DS-LMM model.
}
\details{
Function to run diffcyt-DS-LMM model from the diffcyt package.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_apply_onesimulation_withmarkerinfo}
\alias{function_apply_onesimulation_withmarkerinfo}
\title{One simulation with markers NB information.}
\usage{
function_apply_onesimulation_withmarkerinfo(variation)
}
\arguments{
\item{variation}{list, list of list containing the different input
parameter variations @describeIn function_create_mock_dataset_withmarkerinfo.}
}
\value{
list of simulated data. Each list member contains 5 slots:
    - variation: the variation of input paramaters which has been used in input;
    - df_info: experimental information (donor IDs, group IDs, samples IDs);
    - DE_markers_names: name of the differentially expressed markers;
    - ls_mock_data: list of data.frames, each data.frame being one simulation of
    the cell values using the input parameters provided (list is length nb_sim).
}
\description{
One simulation with markers NB information.
}
\details{
Apply one simulation for a given parameter combination
number times (iterations), when we have prior information about the markers
distribution parameters (mean and dispersion of the negative binomial).
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_to_transform_data}
\alias{function_to_transform_data}
\title{arcsinh transformation.}
\usage{
function_to_transform_data(data, cofactor = 5)
}
\arguments{
\item{data}{data.frame, cell values to transform.}

\item{cofactor}{numeric, co-factor used in the arcsinh (by default
cofactor = 5).}
}
\value{
data.frame of transformed data.
}
\description{
arcsinh transformation.
}
\details{
Function to transform the data with the recommended transformation
for cyTOF data: arcsinh with cofactor equals to 5.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helperfunctions_for_app.R
\name{compute_variance}
\alias{compute_variance}
\title{Compute variance}
\usage{
compute_variance(raw_data_lg)
}
\arguments{
\item{raw_data_lg}{data.frame, cells values in long format.}
}
\value{
numeric, observed variance mean.
}
\description{
Compute variance
}
\details{
Compute the observed variance in the data.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_check_nbDEmarkers}
\alias{function_check_nbDEmarkers}
\title{Number of DE markers greater than 1.}
\usage{
function_check_nbDEmarkers(nb_DEmarker)
}
\arguments{
\item{nb_DEmarker}{numeric, number of differentially expressed markers.}
}
\value{
error message
}
\description{
Number of DE markers greater than 1.
}
\details{
Function to check that the number of DE markers is greater than 1.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models.R
\name{function_run_diffcyt_full_pipeline}
\alias{function_run_diffcyt_full_pipeline}
\title{Run diffcyt pipeline}
\usage{
function_run_diffcyt_full_pipeline(
  onevariation,
  model = c("limma", "LMM"),
  effect = c("random", "fixed")
)
}
\arguments{
\item{onevariation}{list, of simulated data (output of the
function_wrapper_apply_simulation_nbtimes function).}

\item{model}{character, model to run: "limma" or "LMM".}

\item{effect}{character, effect: "random" or "fixed".}
}
\value{
list with 2 slots:
    - model_fit: the model fit;
    - result_summary: results of the model for each marker.
}
\description{
Run diffcyt pipeline
}
\details{
Function to run diffcyt pipeline. We do not used the diffcyt function
directly because of the limma model run differently with the effects.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_DEmarkers_sup_nbmarkers}
\alias{function_DEmarkers_sup_nbmarkers}
\title{Check on the number of DE markers.}
\usage{
function_DEmarkers_sup_nbmarkers(nb_markers, nb_DEmarker)
}
\arguments{
\item{nb_markers}{numeric, total number of markers.}

\item{nb_DEmarker}{numeric, number of differentially expressed markers.}
}
\value{
error message if the number of DE markers is greater than the total
number of markers.
}
\description{
Check on the number of DE markers.
}
\details{
Function to check that number of DE markers greater than number of
markers.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_create_mock_dataset_withmarkerinfo}
\alias{function_create_mock_dataset_withmarkerinfo}
\title{Compute simulated cell values for one simulation with markers NB information.}
\usage{
function_create_mock_dataset_withmarkerinfo(variation)
}
\arguments{
\item{variation}{list, list of data.frames containing the different variable
input paramaters to generate the data:
    - marker_name: name of the marker (character);
    - nb_donor: number of donors;
    - rho: fold change;
    - subject_effect: standard deviation for the normal distribution from
    which the donor's means will be drawn;
    - mu0: mean of the negative binomial for the gamma distribution from
    which the means of the different donor will be drawn;
    - dispersion: dispersion of the negative binomial from
    which the DE marker's cell values will be drawn;
    - nb_cell_per_sample: number of cells per sample.}
}
\value{
list with 4 slots:
    - df_info: data.frame of experimental information;
    - DEmarkers_names: vector of DE marker names;
    - raw_data: data.frame of raw cell values;
    - data: data.frame of transformed cell values.
}
\description{
Compute simulated cell values for one simulation with markers NB information.
}
\details{
Function to compute the simulated cell values using a combination of
variable parameters, when we have prior information about the markers
distribution parameters (mean and dispersion of the negative binomial).
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models_onesim.R
\name{function_apply_modelcomputations_modelchoice}
\alias{function_apply_modelcomputations_modelchoice}
\title{Run DS tests for one simulation.}
\usage{
function_apply_modelcomputations_modelchoice(
  list_combined_output,
  model = c("cytoglmm", "cytoglm", "testDS_limma_random", "testDS_limma_fixed",
    "testDS_lmm")
)
}
\arguments{
\item{list_combined_output}{list, of simulated data (output of the
function_apply_onesimulation_withmarkerinfo function).}

\item{model}{vector, name(s) of models to test.}
}
\value{
data.frame of results for each simulation.
}
\description{
Run DS tests for one simulation.
}
\details{
Wrapper to run the models through the different simulations.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models.R
\name{function_compute_diffcyt_features}
\alias{function_compute_diffcyt_features}
\title{Compute cells counts and medians.}
\usage{
function_compute_diffcyt_features(mock_flowset)
}
\arguments{
\item{mock_flowset}{data.frame, cell values for each marker.}
}
\value{
list with cell counts and medians for each markers.
}
\description{
Compute cells counts and medians.
}
\details{
Function to calculate features for diffcyt package models.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_check_nbmarkers}
\alias{function_check_nbmarkers}
\title{Number of markers greater than 2.}
\usage{
function_check_nbmarkers(nb_marker)
}
\arguments{
\item{nb_marker}{numeric, total number of markers.}
}
\value{
error message if the total number of markers is lower than 3.
}
\description{
Number of markers greater than 2.
}
\details{
Function to check that the number of markers is greater than 2.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models.R
\name{function_run_cytoGLMM}
\alias{function_run_cytoGLMM}
\title{Run cytoglmm}
\usage{
function_run_cytoGLMM(mock_dataset)
}
\arguments{
\item{mock_dataset}{data.frame, cell values for each marker.}
}
\value{
list of 3 slots:
    - model_fit: fit of the model;
    - plot: plot of the effects;
    - results_summary: data.frame containing the results of the models for
    each marker.
}
\description{
Run cytoglmm
}
\details{
Function to run GLMM model from CytoGLMM package.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models_onesim.R
\name{function_to_compute_model_computation_onesimulation_modelchoice}
\alias{function_to_compute_model_computation_onesimulation_modelchoice}
\title{Run DS tests for one simulation.}
\usage{
function_to_compute_model_computation_onesimulation_modelchoice(
  onevariation,
  model
)
}
\arguments{
\item{onevariation}{list, of simulated data (output of the
function_wrapper_apply_simulation_nbtimes function).}

\item{model}{vector, name(s) of models to test.}
}
\value{
data.frame of results for each simulation all models combined.
}
\description{
Run DS tests for one simulation.
}
\details{
Function to run the DS tests through the different models.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models.R
\name{function_run_bootstrapcytoGLMM}
\alias{function_run_bootstrapcytoGLMM}
\title{Run cytoglm.}
\usage{
function_run_bootstrapcytoGLMM(mock_dataset, nb_bootstrap = 500)
}
\arguments{
\item{mock_dataset}{data.frame, cell values for each marker.}

\item{nb_bootstrap}{numeric, number of bootstrap (by defaults nb_bootstrap = 1000).}
}
\value{
list of 3 slots:
    - model_fit: fit of the model;
    - plot: plot of the effects;
    - results_summary: data.frame containing the results of the models for
    each marker.
}
\description{
Run cytoglm.
}
\details{
Function to run the Generalized Linear Model with Bootstrap,
from the CytoGLMM package.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_is_data_paired}
\alias{function_is_data_paired}
\title{Data paired.}
\usage{
function_is_data_paired(data)
}
\arguments{
\item{data}{data.frame, experimental information containing (sample IDS,
donor IDs).}
}
\value{
logical, TRUE is the data are paired - FALSE if the data are not paired
}
\description{
Data paired.
}
\details{
Function to check if the data is paired.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helperfunctions_for_app.R
\name{compute_effectsize}
\alias{compute_effectsize}
\title{Compute effect size}
\usage{
compute_effectsize(raw_data_lg)
}
\arguments{
\item{raw_data_lg}{data.frame, cells values in long format.}
}
\value{
data.frame, Cohen's effect size and fold change that were observed
in the data for each marker.
}
\description{
Compute effect size
}
\details{
Compute observed Cohen's effect size and observed fold change.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarize_model_results.R
\name{function_summary_results_models}
\alias{function_summary_results_models}
\title{Summarize data and results.}
\usage{
function_summary_results_models(summary_from_model, package)
}
\arguments{
\item{summary_from_model}{list, output from the functions running the models.}

\item{package}{character, package used to run the test: "CytoGLMM" or "diffcyt".}
}
\value{
data.frame of results for each simulation.
}
\description{
Summarize data and results.
}
\details{
Function to do a summary of the tested data and model's results
  for the CytoGLMM and diffcyt packages.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_value_onemarker}
\alias{function_value_onemarker}
\title{Compute simulated cell values for one marker with markers NB informations}
\usage{
function_value_onemarker(
  marker_name,
  mu0,
  dispersion,
  subject_effect,
  nb_donor,
  nb_cell_per_sample,
  rho = 1
)
}
\arguments{
\item{marker_name}{character, name of the marker.}

\item{mu0}{numeric, general donor mean from which the individual mu0i will
be drawn.}

\item{dispersion}{numeric, dispersion of the markers.}

\item{subject_effect}{numeric, standard deviation for the normal distribution
from which the donor's means will be drawn (by default subject_effect = 0.01).}

\item{nb_donor}{numeric, number of donors.}

\item{nb_cell_per_sample}{numeric, number of cells per sample (by default
nb_cell_per_sample = 500).}

\item{rho}{numeric, fold change.}
}
\value{
data.frame of cell values.
}
\description{
Compute simulated cell values for one marker with markers NB informations
}
\details{
Function to generate value for one marker with a mean and dispersion
specified for the negative binomiale.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_models.R
\name{function_desigmat_contrast_diffcytDSlimma_fixedeffect}
\alias{function_desigmat_contrast_diffcytDSlimma_fixedeffect}
\title{Design and contrast matrices for diffcyt-DS-limma with fixed effect.}
\usage{
function_desigmat_contrast_diffcytDSlimma_fixedeffect(df_experiment_info)
}
\arguments{
\item{df_experiment_info}{data.frame, information about the experiment (donor IDs,
group IDs and sample IDs).}
}
\value{
list with 3 slots:
    - design_matrix: the design matrix;
    - contrast: the contrast matrix;
    - effect: the specification of the "fixed" effect.
}
\description{
Design and contrast matrices for diffcyt-DS-limma with fixed effect.
}
\details{
Function to create the design matrix and contrast for the diffcyt-DS-limma model
with fixed effect.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CyTOFpower.R, R/app.R
\docType{package}
\name{CyTOFpower}
\alias{CyTOFpower}
\title{CyTOFpower: R-package to predict the power of a CyTOF experiment}
\usage{
CyTOFpower()
}
\value{
Interactive shiny app.
}
\description{
This package provides functions and a shiny app to predict the power of a
CyTOF experiment.

Interactive shiny app to predict the power of a CyTOF experiment.
}
\examples{
# Launch the shiny app
if (interactive()) {
  CyTOFpower()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_generation_nb_parameters_optimized.R
\name{function_extract_marker_names}
\alias{function_extract_marker_names}
\title{Extract marker names.}
\usage{
function_extract_marker_names(mock_dataset)
}
\arguments{
\item{mock_dataset}{data.frame, containing the cell values for each marker.}
}
\value{
vector of marker names.
}
\description{
Extract marker names.
}
\details{
Function to extract the marker names.
}
\keyword{internal}
